(function () {
    'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
            if (ar || !(i in from)) {
                if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                ar[i] = from[i];
            }
        }
        return to.concat(ar || Array.prototype.slice.call(from));
    }

    function createCommonjsModule(fn) {
      var module = { exports: {} };
    	return fn(module, module.exports), module.exports;
    }

    var label = 'MB Tracker: ';
    var LOG_LEVEL;
    (function (LOG_LEVEL) {
        LOG_LEVEL[LOG_LEVEL["none"] = 0] = "none";
        LOG_LEVEL[LOG_LEVEL["error"] = 1] = "error";
        LOG_LEVEL[LOG_LEVEL["warn"] = 2] = "warn";
        LOG_LEVEL[LOG_LEVEL["debug"] = 3] = "debug";
        LOG_LEVEL[LOG_LEVEL["info"] = 4] = "info";
    })(LOG_LEVEL || (LOG_LEVEL = {}));
    var LOG$1 = logger();
    function logger(logLevel) {
        if (logLevel === void 0) { logLevel = LOG_LEVEL.warn; }
        function setLogLevel(level) {
            if (LOG_LEVEL[level]) {
                logLevel = level;
            }
            else {
                logLevel = LOG_LEVEL.warn;
            }
        }
        /**
         * Log errors, with or without error object
         */
        function error(message, error) {
            var extraParams = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                extraParams[_i - 2] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.error && typeof console !== 'undefined') {
                var logMsg = label + message + '\n';
                if (error) {
                    console.error.apply(console, __spreadArray([logMsg + '\n', error], extraParams));
                }
                else {
                    console.error.apply(console, __spreadArray([logMsg], extraParams));
                }
            }
        }
        /**
         * Log warnings, with or without error object
         */
        function warn(message, error) {
            var extraParams = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                extraParams[_i - 2] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.warn && typeof console !== 'undefined') {
                var logMsg = label + message;
                if (error) {
                    console.warn.apply(console, __spreadArray([logMsg + '\n', error], extraParams));
                }
                else {
                    console.warn.apply(console, __spreadArray([logMsg], extraParams));
                }
            }
        }
        /**
         * Log debug messages
         */
        function debug(message) {
            var extraParams = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                extraParams[_i - 1] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.debug && typeof console !== 'undefined') {
                console.debug.apply(console, __spreadArray([label + message], extraParams));
            }
        }
        /**
         * Log info messages
         */
        function info(message) {
            var extraParams = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                extraParams[_i - 1] = arguments[_i];
            }
            if (logLevel >= LOG_LEVEL.info && typeof console !== 'undefined') {
                console.info.apply(console, __spreadArray([label + message], extraParams));
            }
        }
        return { setLogLevel: setLogLevel, warn: warn, error: error, debug: debug, info: info };
    }

    var lzString = createCommonjsModule(function (module) {
    // Copyright (c) 2013 Pieroxy <pieroxy@pieroxy.net>
    // This work is free. You can redistribute it and/or modify it
    // under the terms of the WTFPL, Version 2
    // For more information see LICENSE.txt or http://www.wtfpl.net/
    //
    // For more information, the home page:
    // http://pieroxy.net/blog/pages/lz-string/testing.html
    //
    // LZ-based compression algorithm, version 1.4.4
    var LZString = (function() {

    // private property
    var f = String.fromCharCode;
    var keyStrBase64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    var keyStrUriSafe = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+-$";
    var baseReverseDic = {};

    function getBaseValue(alphabet, character) {
      if (!baseReverseDic[alphabet]) {
        baseReverseDic[alphabet] = {};
        for (var i=0 ; i<alphabet.length ; i++) {
          baseReverseDic[alphabet][alphabet.charAt(i)] = i;
        }
      }
      return baseReverseDic[alphabet][character];
    }

    var LZString = {
      compressToBase64 : function (input) {
        if (input == null) return "";
        var res = LZString._compress(input, 6, function(a){return keyStrBase64.charAt(a);});
        switch (res.length % 4) { // To produce valid Base64
        default: // When could this happen ?
        case 0 : return res;
        case 1 : return res+"===";
        case 2 : return res+"==";
        case 3 : return res+"=";
        }
      },

      decompressFromBase64 : function (input) {
        if (input == null) return "";
        if (input == "") return null;
        return LZString._decompress(input.length, 32, function(index) { return getBaseValue(keyStrBase64, input.charAt(index)); });
      },

      compressToUTF16 : function (input) {
        if (input == null) return "";
        return LZString._compress(input, 15, function(a){return f(a+32);}) + " ";
      },

      decompressFromUTF16: function (compressed) {
        if (compressed == null) return "";
        if (compressed == "") return null;
        return LZString._decompress(compressed.length, 16384, function(index) { return compressed.charCodeAt(index) - 32; });
      },

      //compress into uint8array (UCS-2 big endian format)
      compressToUint8Array: function (uncompressed) {
        var compressed = LZString.compress(uncompressed);
        var buf=new Uint8Array(compressed.length*2); // 2 bytes per character

        for (var i=0, TotalLen=compressed.length; i<TotalLen; i++) {
          var current_value = compressed.charCodeAt(i);
          buf[i*2] = current_value >>> 8;
          buf[i*2+1] = current_value % 256;
        }
        return buf;
      },

      //decompress from uint8array (UCS-2 big endian format)
      decompressFromUint8Array:function (compressed) {
        if (compressed===null || compressed===undefined){
            return LZString.decompress(compressed);
        } else {
            var buf=new Array(compressed.length/2); // 2 bytes per character
            for (var i=0, TotalLen=buf.length; i<TotalLen; i++) {
              buf[i]=compressed[i*2]*256+compressed[i*2+1];
            }

            var result = [];
            buf.forEach(function (c) {
              result.push(f(c));
            });
            return LZString.decompress(result.join(''));

        }

      },


      //compress into a string that is already URI encoded
      compressToEncodedURIComponent: function (input) {
        if (input == null) return "";
        return LZString._compress(input, 6, function(a){return keyStrUriSafe.charAt(a);});
      },

      //decompress from an output of compressToEncodedURIComponent
      decompressFromEncodedURIComponent:function (input) {
        if (input == null) return "";
        if (input == "") return null;
        input = input.replace(/ /g, "+");
        return LZString._decompress(input.length, 32, function(index) { return getBaseValue(keyStrUriSafe, input.charAt(index)); });
      },

      compress: function (uncompressed) {
        return LZString._compress(uncompressed, 16, function(a){return f(a);});
      },
      _compress: function (uncompressed, bitsPerChar, getCharFromInt) {
        if (uncompressed == null) return "";
        var i, value,
            context_dictionary= {},
            context_dictionaryToCreate= {},
            context_c="",
            context_wc="",
            context_w="",
            context_enlargeIn= 2, // Compensate for the first entry which should not count
            context_dictSize= 3,
            context_numBits= 2,
            context_data=[],
            context_data_val=0,
            context_data_position=0,
            ii;

        for (ii = 0; ii < uncompressed.length; ii += 1) {
          context_c = uncompressed.charAt(ii);
          if (!Object.prototype.hasOwnProperty.call(context_dictionary,context_c)) {
            context_dictionary[context_c] = context_dictSize++;
            context_dictionaryToCreate[context_c] = true;
          }

          context_wc = context_w + context_c;
          if (Object.prototype.hasOwnProperty.call(context_dictionary,context_wc)) {
            context_w = context_wc;
          } else {
            if (Object.prototype.hasOwnProperty.call(context_dictionaryToCreate,context_w)) {
              if (context_w.charCodeAt(0)<256) {
                for (i=0 ; i<context_numBits ; i++) {
                  context_data_val = (context_data_val << 1);
                  if (context_data_position == bitsPerChar-1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }
                }
                value = context_w.charCodeAt(0);
                for (i=0 ; i<8 ; i++) {
                  context_data_val = (context_data_val << 1) | (value&1);
                  if (context_data_position == bitsPerChar-1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }
                  value = value >> 1;
                }
              } else {
                value = 1;
                for (i=0 ; i<context_numBits ; i++) {
                  context_data_val = (context_data_val << 1) | value;
                  if (context_data_position ==bitsPerChar-1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }
                  value = 0;
                }
                value = context_w.charCodeAt(0);
                for (i=0 ; i<16 ; i++) {
                  context_data_val = (context_data_val << 1) | (value&1);
                  if (context_data_position == bitsPerChar-1) {
                    context_data_position = 0;
                    context_data.push(getCharFromInt(context_data_val));
                    context_data_val = 0;
                  } else {
                    context_data_position++;
                  }
                  value = value >> 1;
                }
              }
              context_enlargeIn--;
              if (context_enlargeIn == 0) {
                context_enlargeIn = Math.pow(2, context_numBits);
                context_numBits++;
              }
              delete context_dictionaryToCreate[context_w];
            } else {
              value = context_dictionary[context_w];
              for (i=0 ; i<context_numBits ; i++) {
                context_data_val = (context_data_val << 1) | (value&1);
                if (context_data_position == bitsPerChar-1) {
                  context_data_position = 0;
                  context_data.push(getCharFromInt(context_data_val));
                  context_data_val = 0;
                } else {
                  context_data_position++;
                }
                value = value >> 1;
              }


            }
            context_enlargeIn--;
            if (context_enlargeIn == 0) {
              context_enlargeIn = Math.pow(2, context_numBits);
              context_numBits++;
            }
            // Add wc to the dictionary.
            context_dictionary[context_wc] = context_dictSize++;
            context_w = String(context_c);
          }
        }

        // Output the code for w.
        if (context_w !== "") {
          if (Object.prototype.hasOwnProperty.call(context_dictionaryToCreate,context_w)) {
            if (context_w.charCodeAt(0)<256) {
              for (i=0 ; i<context_numBits ; i++) {
                context_data_val = (context_data_val << 1);
                if (context_data_position == bitsPerChar-1) {
                  context_data_position = 0;
                  context_data.push(getCharFromInt(context_data_val));
                  context_data_val = 0;
                } else {
                  context_data_position++;
                }
              }
              value = context_w.charCodeAt(0);
              for (i=0 ; i<8 ; i++) {
                context_data_val = (context_data_val << 1) | (value&1);
                if (context_data_position == bitsPerChar-1) {
                  context_data_position = 0;
                  context_data.push(getCharFromInt(context_data_val));
                  context_data_val = 0;
                } else {
                  context_data_position++;
                }
                value = value >> 1;
              }
            } else {
              value = 1;
              for (i=0 ; i<context_numBits ; i++) {
                context_data_val = (context_data_val << 1) | value;
                if (context_data_position == bitsPerChar-1) {
                  context_data_position = 0;
                  context_data.push(getCharFromInt(context_data_val));
                  context_data_val = 0;
                } else {
                  context_data_position++;
                }
                value = 0;
              }
              value = context_w.charCodeAt(0);
              for (i=0 ; i<16 ; i++) {
                context_data_val = (context_data_val << 1) | (value&1);
                if (context_data_position == bitsPerChar-1) {
                  context_data_position = 0;
                  context_data.push(getCharFromInt(context_data_val));
                  context_data_val = 0;
                } else {
                  context_data_position++;
                }
                value = value >> 1;
              }
            }
            context_enlargeIn--;
            if (context_enlargeIn == 0) {
              context_enlargeIn = Math.pow(2, context_numBits);
              context_numBits++;
            }
            delete context_dictionaryToCreate[context_w];
          } else {
            value = context_dictionary[context_w];
            for (i=0 ; i<context_numBits ; i++) {
              context_data_val = (context_data_val << 1) | (value&1);
              if (context_data_position == bitsPerChar-1) {
                context_data_position = 0;
                context_data.push(getCharFromInt(context_data_val));
                context_data_val = 0;
              } else {
                context_data_position++;
              }
              value = value >> 1;
            }


          }
          context_enlargeIn--;
          if (context_enlargeIn == 0) {
            context_enlargeIn = Math.pow(2, context_numBits);
            context_numBits++;
          }
        }

        // Mark the end of the stream
        value = 2;
        for (i=0 ; i<context_numBits ; i++) {
          context_data_val = (context_data_val << 1) | (value&1);
          if (context_data_position == bitsPerChar-1) {
            context_data_position = 0;
            context_data.push(getCharFromInt(context_data_val));
            context_data_val = 0;
          } else {
            context_data_position++;
          }
          value = value >> 1;
        }

        // Flush the last char
        while (true) {
          context_data_val = (context_data_val << 1);
          if (context_data_position == bitsPerChar-1) {
            context_data.push(getCharFromInt(context_data_val));
            break;
          }
          else context_data_position++;
        }
        return context_data.join('');
      },

      decompress: function (compressed) {
        if (compressed == null) return "";
        if (compressed == "") return null;
        return LZString._decompress(compressed.length, 32768, function(index) { return compressed.charCodeAt(index); });
      },

      _decompress: function (length, resetValue, getNextValue) {
        var dictionary = [],
            enlargeIn = 4,
            dictSize = 4,
            numBits = 3,
            entry = "",
            result = [],
            i,
            w,
            bits, resb, maxpower, power,
            c,
            data = {val:getNextValue(0), position:resetValue, index:1};

        for (i = 0; i < 3; i += 1) {
          dictionary[i] = i;
        }

        bits = 0;
        maxpower = Math.pow(2,2);
        power=1;
        while (power!=maxpower) {
          resb = data.val & data.position;
          data.position >>= 1;
          if (data.position == 0) {
            data.position = resetValue;
            data.val = getNextValue(data.index++);
          }
          bits |= (resb>0 ? 1 : 0) * power;
          power <<= 1;
        }

        switch (bits) {
          case 0:
              bits = 0;
              maxpower = Math.pow(2,8);
              power=1;
              while (power!=maxpower) {
                resb = data.val & data.position;
                data.position >>= 1;
                if (data.position == 0) {
                  data.position = resetValue;
                  data.val = getNextValue(data.index++);
                }
                bits |= (resb>0 ? 1 : 0) * power;
                power <<= 1;
              }
            c = f(bits);
            break;
          case 1:
              bits = 0;
              maxpower = Math.pow(2,16);
              power=1;
              while (power!=maxpower) {
                resb = data.val & data.position;
                data.position >>= 1;
                if (data.position == 0) {
                  data.position = resetValue;
                  data.val = getNextValue(data.index++);
                }
                bits |= (resb>0 ? 1 : 0) * power;
                power <<= 1;
              }
            c = f(bits);
            break;
          case 2:
            return "";
        }
        dictionary[3] = c;
        w = c;
        result.push(c);
        while (true) {
          if (data.index > length) {
            return "";
          }

          bits = 0;
          maxpower = Math.pow(2,numBits);
          power=1;
          while (power!=maxpower) {
            resb = data.val & data.position;
            data.position >>= 1;
            if (data.position == 0) {
              data.position = resetValue;
              data.val = getNextValue(data.index++);
            }
            bits |= (resb>0 ? 1 : 0) * power;
            power <<= 1;
          }

          switch (c = bits) {
            case 0:
              bits = 0;
              maxpower = Math.pow(2,8);
              power=1;
              while (power!=maxpower) {
                resb = data.val & data.position;
                data.position >>= 1;
                if (data.position == 0) {
                  data.position = resetValue;
                  data.val = getNextValue(data.index++);
                }
                bits |= (resb>0 ? 1 : 0) * power;
                power <<= 1;
              }

              dictionary[dictSize++] = f(bits);
              c = dictSize-1;
              enlargeIn--;
              break;
            case 1:
              bits = 0;
              maxpower = Math.pow(2,16);
              power=1;
              while (power!=maxpower) {
                resb = data.val & data.position;
                data.position >>= 1;
                if (data.position == 0) {
                  data.position = resetValue;
                  data.val = getNextValue(data.index++);
                }
                bits |= (resb>0 ? 1 : 0) * power;
                power <<= 1;
              }
              dictionary[dictSize++] = f(bits);
              c = dictSize-1;
              enlargeIn--;
              break;
            case 2:
              return result.join('');
          }

          if (enlargeIn == 0) {
            enlargeIn = Math.pow(2, numBits);
            numBits++;
          }

          if (dictionary[c]) {
            entry = dictionary[c];
          } else {
            if (c === dictSize) {
              entry = w + w.charAt(0);
            } else {
              return null;
            }
          }
          result.push(entry);

          // Add w+entry[0] to the dictionary.
          dictionary[dictSize++] = w + entry.charAt(0);
          enlargeIn--;

          w = entry;

          if (enlargeIn == 0) {
            enlargeIn = Math.pow(2, numBits);
            numBits++;
          }

        }
      }
    };
      return LZString;
    })();

    if( module != null ) {
      module.exports = LZString;
    }
    });

    var CoreApi = /** @class */ (function () {
        function CoreApi(core) {
            this.core = core;
        }
        CoreApi.prototype.setUserId = function (id, email) {
            var _a;
            var globalStateManager = this.core.context.globalStateManager;
            if (!globalStateManager || (!id && !email)) {
                return;
            }
            var state = globalStateManager.get({});
            globalStateManager.set(__assign(__assign({}, state), { user: {
                    id: id,
                    email: email || ((_a = state === null || state === void 0 ? void 0 : state.user) === null || _a === void 0 ? void 0 : _a.email),
                } }));
        };
        return CoreApi;
    }());

    var prefix = 'MB Onsite:';
    var applyPrefix = function (args) {
        args.unshift('color:#259fa5;font-weight:bold');
        args.unshift('%c' + prefix);
        return args;
    };
    var LOG = {
        debug: function () {
            var _a;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            applyPrefix(args);
            ((_a = window === null || window === void 0 ? void 0 : window.MailbizOnsite) === null || _a === void 0 ? void 0 : _a.debug) && console.log.apply(console, args);
        },
        warn: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            applyPrefix(args);
            console.warn.apply(console, args);
        },
        log: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            applyPrefix(args);
            console.log.apply(console, args);
        },
        error: function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            applyPrefix(args);
            console.error.apply(console, args);
        },
    };
    var throttle = function (fn, wait, options) {
        if (wait === void 0) { wait = 300; }
        var baseOptions = {
            leading: true, // Calls the function immediately at the start of the throttle period
        };
        options = __assign(__assign({}, baseOptions), options);
        var inThrottle;
        var currentTimeout;
        var lastTime;
        var timeoutResetThrottle = function () {
            currentTimeout = setTimeout(function () {
                inThrottle = false;
            }, wait);
        };
        var callFn = function (context, args) {
            fn.apply(context, args);
            lastTime = Date.now();
            timeoutResetThrottle();
        };
        var timeoutCallFn = function (context, args) {
            clearTimeout(currentTimeout);
            currentTimeout = setTimeout(function () {
                callFn(context, args);
            }, Math.max(wait - (Date.now() - lastTime), 0));
        };
        return function () {
            var context = this;
            /* eslint prefer-rest-params: "off" */
            var args = arguments;
            if (!inThrottle && options.leading) {
                callFn(context, args);
            }
            else {
                timeoutCallFn(context, args);
            }
            inThrottle = true;
        };
    };
    // @Param obj - should be an object or an array
    var isEmptyObject = function (obj) {
        if (typeof obj !== 'object') {
            return false;
        }
        try {
            return Object.keys(obj).length <= 0;
        }
        catch (_err) {
            return false;
        }
    };
    var capitalize = function (input) {
        if (!input || !input.charAt) {
            return '';
        }
        return "" + input.charAt(0).toUpperCase() + input.slice(1);
    };
    var base64ToString = function (input) {
        if (!window.atob)
            return '';
        return decodeURIComponent(escape(window.atob(input)));
    };
    var isWindowIframe = function () {
        try {
            return window.self !== window.top;
        }
        catch (e) {
            return true;
        }
    };
    function tryToParseJson(value) {
        try {
            var parsedData = JSON.parse(value);
            return parsedData;
        }
        catch (_a) {
            return null;
        }
    }
    var fixUrlIfNeeded = function (url) {
        var _a, _b, _c;
        if (typeof url !== 'string' || !url) {
            return undefined;
        }
        // Protocol
        var missingProtocol = url.indexOf('http://') !== 0 && url.indexOf('https://') !== 0;
        if (missingProtocol) {
            var protocol = ((_b = (_a = window === null || window === void 0 ? void 0 : window.location) === null || _a === void 0 ? void 0 : _a.protocol) === null || _b === void 0 ? void 0 : _b.includes('http')) ? (_c = window === null || window === void 0 ? void 0 : window.location) === null || _c === void 0 ? void 0 : _c.protocol : 'https:';
            var hasDoubleSlash = (url === null || url === void 0 ? void 0 : url.indexOf('//')) === 0;
            var protocolString = hasDoubleSlash ? "" + protocol : protocol + "//";
            url = "" + protocolString + url;
        }
        var protocolLength = url.indexOf('://') + 3;
        var fixedUrl = url.slice(0, protocolLength);
        // Double, leading and trailing slashes
        for (var i = protocolLength; i < url.length; i++) {
            if (url[i] !== '/') {
                // Optimize loop
                fixedUrl += url[i];
                continue;
            }
            if (
            // Look ahead to avoid double slash
            url[i + 1] === '/' ||
                // Remove trailing slash
                i === url.length - 1 ||
                // Avoid double slash after protocol
                fixedUrl.length === protocolLength) {
                continue;
            }
            fixedUrl += url[i];
        }
        return fixedUrl;
    };

    //https://pieroxy.net/blog/pages/lz-string/guide.html
    var compressToEncodedURIComponent = function (input) {
        try {
            return lzString.compressToEncodedURIComponent(input);
        }
        catch (err) {
            LOG$1.debug('compress error', err);
            return '';
        }
    };
    //https://pieroxy.net/blog/pages/lz-string/guide.html
    var decompressFromEncodedURIComponent = function (input) {
        try {
            return lzString.decompressFromEncodedURIComponent(input);
        }
        catch (err) {
            LOG$1.debug('compress error', err);
            return '';
        }
    };

    function isDifferent(currentVal, newVal, keys) {
        var keysToCheck = keys;
        if (keysToCheck == null) {
            var currentValKeys = Object.keys(currentVal);
            var newValKeys = Object.keys(newVal);
            if (currentValKeys.length !== newValKeys.length) {
                return true;
            }
            else if (currentValKeys.length === 0 && newValKeys.length === 0) {
                return false;
            }
            else {
                keysToCheck = currentValKeys;
            }
        }
        var different = false;
        keysToCheck.forEach(function (key) {
            if (different === true) {
                return;
            }
            if (typeof currentVal[key] === 'object' && typeof newVal[key] === 'object') {
                if (isDifferent((currentVal[key] || {}), (newVal[key] || {}))) {
                    different = true;
                }
                return;
            }
            if (currentVal[key] !== newVal[key]) {
                different = true;
                return;
            }
        });
        return different;
    }
    var CookieStorageAdapter = /** @class */ (function () {
        function CookieStorageAdapter() {
        }
        CookieStorageAdapter.prototype.getItem = function (name) {
            var nameEQ = name + '=';
            var ca = window.document.cookie.split(';');
            for (var i = 0; i < ca.length; i++) {
                var c = ca[i];
                while (c.charAt(0) == ' ')
                    c = c.substring(1, c.length);
                if (c.indexOf(nameEQ) == 0)
                    return c.substring(nameEQ.length, c.length);
            }
            return null;
        };
        CookieStorageAdapter.prototype.removeItem = function (name) {
            window.document.cookie = name + '=; Max-Age=-99999999;';
        };
        CookieStorageAdapter.prototype.setItem = function (name, value) {
            var days = 30;
            var expires = '';
            {
                var date = new Date();
                date.setTime(date.getTime() + days * 24 * 60 * 60 * 1000);
                expires = '; expires=' + date.toUTCString();
            }
            window.document.cookie = name + '=' + (value || '') + expires + '; path=/';
        };
        return CookieStorageAdapter;
    }());
    var StorageFactoryType;
    (function (StorageFactoryType) {
        StorageFactoryType["session"] = "session";
        StorageFactoryType["local"] = "local";
        StorageFactoryType["cookie"] = "cookie";
    })(StorageFactoryType || (StorageFactoryType = {}));
    /**
     * Create the storage constructor
     * @param {String}  id      The storage ID
     * @param {enum} sessionType 'local' | 'session' | 'cookie'
     */
    var StorageFactory = /** @class */ (function () {
        function StorageFactory(name, expires, sessionType) {
            this.id = "mb_" + name;
            // should be less than session expiration time
            this.expires = expires !== null && expires !== void 0 ? expires : 60 * 25; // 25 min default
            var supportsLocalStorage = typeof window.localStorage !== 'undefined';
            this.sessionType = sessionType !== null && sessionType !== void 0 ? sessionType : (supportsLocalStorage ? StorageFactoryType.local : StorageFactoryType.cookie);
            this.storage =
                this.sessionType === StorageFactoryType.cookie
                    ? new CookieStorageAdapter()
                    : this.sessionType === StorageFactoryType.local
                        ? window.localStorage
                        : window.sessionStorage;
        }
        StorageFactory.prototype.set = function (data) {
            try {
                var expires = this.expires;
                var item = compressToEncodedURIComponent(JSON.stringify({
                    expires: expires ? new Date().getTime() + expires * 1000 : null,
                    data: data,
                }));
                if (!this.itemExceedsSizeLimit(item)) {
                    this.storage.setItem(this.id, item);
                }
                else {
                    LOG.debug("Storage " + this.id + " exceeded size limit and was cleared");
                    this.remove();
                }
            }
            catch (_er) { }
        };
        StorageFactory.prototype.get = function (fallback, ignoreExpiration) {
            var _a;
            try {
                var str = (_a = this.storage.getItem(this.id)) !== null && _a !== void 0 ? _a : '';
                var rawData = decompressFromEncodedURIComponent(str);
                var data = rawData ? JSON.parse(rawData) : undefined;
                if (!data || !(data === null || data === void 0 ? void 0 : data.data)) {
                    throw new Error('No data');
                }
                if (ignoreExpiration || isExpirationTimeValid(data.expires)) {
                    return data === null || data === void 0 ? void 0 : data.data;
                }
                this.remove();
            }
            catch (_er) { }
            return __assign({}, fallback);
        };
        StorageFactory.prototype.isValid = function () {
            var _a;
            var rawData = decompressFromEncodedURIComponent((_a = this.storage.getItem(this.id)) !== null && _a !== void 0 ? _a : '');
            var data = rawData ? JSON.parse(rawData) : undefined;
            if (!data) {
                return false;
            }
            return isExpirationTimeValid(data.expires);
        };
        StorageFactory.prototype.renewExpirationDate = function () {
            try {
                var data = this.get({}, true);
                this.set(data);
            }
            catch (_er) { }
        };
        StorageFactory.prototype.remove = function () {
            this.storage.removeItem(this.id);
        };
        StorageFactory.prototype.itemExceedsSizeLimit = function (item) {
            // Avoid Object.values for IE 10 support
            var values = Object.keys(item).map(function (key) { return item[key]; });
            var size = new Blob(values).size; // has IE 10 support
            var limit = this.sessionType === StorageFactoryType.cookie ? 2000 : 20000; // 2KB or 20KB
            return size > limit;
        };
        return StorageFactory;
    }());
    /**
     * Check if an expiration date has past or not
     * @param  {Integer} expires The expiration timestamp
     * @return {Boolean}         If true, data is still valid
     */
    function isExpirationTimeValid(expires) {
        // If there's no expiration date, return true
        if (expires === null)
            return true;
        try {
            // Get the difference between the timestamp and expiration date
            var difference = expires - new Date().getTime();
            // Check if the data has expired
            return difference > 0;
        }
        catch (_er) { }
        return true;
    }

    var Url = /** @class */ (function () {
        function Url() {
        }
        Url.getQueryParameters = function (url) {
            url = url || window.location.href;
            var parameters = {};
            var parametersString = url.split('?')[1];
            if (!parametersString) {
                return parameters;
            }
            parametersString = parametersString.split('/#')[0].split('#')[0];
            var parametersArray = parametersString.split('&');
            for (var i = 0; i < parametersArray.length; i++) {
                var pair = parametersArray[i].split('=');
                var key = pair === null || pair === void 0 ? void 0 : pair[0];
                if (key) {
                    var value = void 0;
                    try {
                        value = decodeURIComponent(pair[1]);
                    }
                    catch (_a) {
                        value = (pair === null || pair === void 0 ? void 0 : pair[1]) || '';
                    }
                    parameters[key] = value;
                }
            }
            return parameters;
        };
        Url.addQueryParameters = function (url, parameters) {
            var urlObject = new URL(url);
            var urlParameters = urlObject.searchParams;
            Object.keys(parameters).forEach(function (key) {
                urlParameters.set(key, parameters[key]);
            });
            urlObject.search = urlParameters.toString();
            return urlObject.toString();
        };
        Url.redirectAddingCurrentUtmParameters = function (url) {
            url = url[0] === '/' ? "" + window.location.origin + url : url;
            var currentQueryParams = Url.getQueryParameters();
            var utmParametersList = Object.keys(Url.UtmParameters);
            var newUtmOnlyParameters = {};
            utmParametersList.forEach(function (utmName) {
                if (typeof currentQueryParams[utmName] === 'undefined') {
                    return;
                }
                newUtmOnlyParameters[utmName] = currentQueryParams[utmName];
            });
            window.location.replace(Url.addQueryParameters(url, newUtmOnlyParameters));
        };
        Url.UtmParameters = {
            utm_source: 'utm_source',
            utm_medium: 'utm_medium',
            utm_campaign: 'utm_campaign',
            utm_journey: 'utm_journey',
            utm_journey_channel: 'utm_journey_channel',
            utm_journey_type: 'utm_journey_type',
        };
        return Url;
    }());

    // #endregion
    // #region [Event definition]
    // All events
    var Events;
    (function (Events) {
        Events["pageView"] = "pageView";
        Events["accountLogin"] = "accountLogin";
        Events["accountSync"] = "accountSync";
        Events["productView"] = "productView";
        Events["cartSync"] = "cartSync";
        Events["addToCart"] = "addToCart";
        Events["cartItemUpdate"] = "cartItemUpdate";
        Events["cartSetPostalCode"] = "cartSetPostalCode";
        Events["cartSetCoupon"] = "cartSetCoupon";
        Events["checkoutStep"] = "checkoutStep";
        Events["orderComplete"] = "orderComplete";
        Events["orderCancel"] = "orderCancel";
    })(Events || (Events = {}));
    // #endregion

    var EventsState = /** @class */ (function () {
        function EventsState(appId) {
            var storageName = "tracker_v_" + appId;
            this.eventsStateManager = new StorageFactory(storageName);
        }
        EventsState.prototype.shouldOptimizeAndAvoidTrackingCartSync = function (newEventData, currentEventData) {
            var _a, _b;
            var newItems = (_a = newEventData === null || newEventData === void 0 ? void 0 : newEventData.cart) === null || _a === void 0 ? void 0 : _a.items;
            var currentItems = (_b = currentEventData === null || currentEventData === void 0 ? void 0 : currentEventData.cart) === null || _b === void 0 ? void 0 : _b.items;
            return (newItems === null || newItems === void 0 ? void 0 : newItems.length) === 0 && (currentItems === null || currentItems === void 0 ? void 0 : currentItems.length) === 0;
        };
        EventsState.prototype.shouldTrack = function (name, newEventData, currentEventData) {
            var isCartSyncEvent = name === Events.cartSync;
            if (isCartSyncEvent &&
                this.shouldOptimizeAndAvoidTrackingCartSync(newEventData, currentEventData)) {
                return false;
            }
            return isDifferent(currentEventData, newEventData);
        };
        EventsState.prototype.digestNewEvent = function (name, newEventData) {
            var eventsState = this.getCurrentState();
            var currentEventData = (eventsState === null || eventsState === void 0 ? void 0 : eventsState[name]) || {};
            var shouldTrack = this.shouldTrack(name, newEventData, currentEventData);
            if (shouldTrack) {
                eventsState[name] = newEventData;
                this.eventsStateManager.set(eventsState);
            }
            else {
                // Event is the same, so it still valid
                this.eventsStateManager.renewExpirationDate();
            }
            return { shouldTrack: shouldTrack };
        };
        EventsState.prototype.getCurrentState = function () {
            return this.eventsStateManager.get({});
        };
        return EventsState;
    }());

    var TRACKER_NAME = 'mbtrack';
    var eventsState;
    function loadTracker(m, b, t, r, a, c, k) {
        var _a;
        // Stop if the mbtrack namespace i already exists
        if (!m[a]) {
            // Initialize the 'GlobalMBZNamespace' array
            m['GlobalMBZNamespace'] = (m['GlobalMBZNamespace'] || []);
            // Add the new mbtrack namespace to the global array so tracker.js can find it
            m['GlobalMBZNamespace'].push(a);
            // Create the mbtrack function
            m[a] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                (m[a].q = m[a].q || []).push(args);
            };
            // Initialize the asynchronous queue
            m[a].q = m[a].q || [];
            // Create a new script element
            c = b.createElement(t);
            // Get the first script on the page
            k = b.getElementsByTagName(t)[0];
            // The new script should load asynchronously
            c.async = true;
            // Load mbtrack
            c.src = r;
            // Insert the mbtrack script before every other script so it executes as soon as possible
            (_a = k.parentNode) === null || _a === void 0 ? void 0 : _a.insertBefore(c, k);
        }
    }
    function setVendor() {
        var onsiteSettings = window.MailbizOnsite || {};
        track('setPlatformVendor', onsiteSettings.vendor);
    }
    function setBaseUri() {
        var onsiteSettings = window.MailbizOnsite || {};
        track('setBaseUri', onsiteSettings.baseuri);
    }
    function setRecoveryUrl() {
        var _a;
        var onsiteSettings = window.MailbizOnsite || {};
        var recoveryUrl = (_a = onsiteSettings.features.cartRecovery) === null || _a === void 0 ? void 0 : _a.recoveryUrl;
        if (recoveryUrl) {
            track('setRecoveryUrl', recoveryUrl);
        }
    }
    function setCustomUrl(url) {
        track('setCustomUrl', url);
    }
    function setOnsiteVersion(version) {
        if (version === void 0) { version = ''; }
        track('setOnsiteVersion', version);
    }
    function setUtmNavigationContext(globalState) {
        var state = globalState.get({});
        var _a = state.utmData, utmData = _a === void 0 ? {} : _a;
        var queryParams = Url.getQueryParameters();
        var currentUtmParams = {};
        var utmParametersList = Object.keys(Url.UtmParameters);
        utmParametersList.forEach(function (utmName) {
            if (typeof queryParams[utmName] === 'undefined') {
                return;
            }
            currentUtmParams[utmName] = queryParams[utmName];
        });
        if (!isEmptyObject(currentUtmParams) && isDifferent(utmData, currentUtmParams)) {
            globalState.set(__assign(__assign({}, state), { utmData: currentUtmParams }));
            track('setUtmData', currentUtmParams);
            return;
        }
        if (!isEmptyObject(utmData)) {
            globalState.set(state);
            track('setUtmData', utmData);
        }
    }
    function setNavigationUser(globalState) {
        var state = globalState.get({});
        var _a = state.user, user = _a === void 0 ? {} : _a;
        if (user.id || user.email) {
            track('setUserId', user.id || user.email);
            globalState.set(state);
        }
    }
    var bootstrapTracker = function (initialData) {
        var appId = initialData.appId, _a = initialData.scriptUrl, scriptUrl = _a === void 0 ? 'https://cdn.jsdelivr.net/npm/@mailbiz/javascript-tracker' : _a, collectUrl = initialData.collectUrl, heartbeatDelay = initialData.heartbeatDelay, _b = initialData.connectionTimeout, connectionTimeout = _b === void 0 ? 9999999 : _b;
        if (!appId) {
            LOG.warn('app_id is missing on bootstrapTracker');
            return;
        }
        eventsState = new EventsState(appId);
        // This really is the best way? Think about it
        loadTracker(window, document, 'script', scriptUrl, TRACKER_NAME);
        // Register default Mailbiz Tracker Collector URL
        track('newTracker', 'mbone', collectUrl, {
            appId: appId,
            connectionTimeout: connectionTimeout,
        });
        if (heartbeatDelay && heartbeatDelay > 0) {
            track('enableActivityTracking', {
                minimumVisitLength: heartbeatDelay,
                heartbeatDelay: heartbeatDelay,
            });
        }
        LOG.debug("Tracker " + TRACKER_NAME + " initialized");
    };
    var getCurrentEventsState = function () {
        return eventsState.getCurrentState();
    };
    var track = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        window[TRACKER_NAME] && window[TRACKER_NAME].apply(window[TRACKER_NAME], args);
    };
    var trackIfNeeded = function (event, data, opt) {
        opt = opt || { force: false };
        var shouldTrack = eventsState.digestNewEvent(event, data).shouldTrack;
        if (shouldTrack || (opt === null || opt === void 0 ? void 0 : opt.force)) {
            track(eventsNameTrack[event], data);
        }
        else {
            LOG.debug(capitalize(event) + ": no change, should not update");
        }
    };
    var eventsNameTrack = Object.entries(Events)
        .map(function (_a) {
        var key = _a[0], value = _a[1];
        return [key, "track" + capitalize(value)];
    })
        .reduce(function (acc, _a) {
        var _b;
        var key = _a[0], value = _a[1];
        return (__assign(__assign({}, acc), (_b = {}, _b[key] = value, _b)));
    }, {});
    // All event methods implementations, indexed by the original event name
    var defaultTimer = 200;
    var trackerEventMethods = Object.entries(Events)
        .map(function (_a) {
        var key = _a[0], eventName = _a[1];
        var method = throttle(function (eventData, opt) {
            var eventHasData = Boolean(eventData);
            if (eventHasData) {
                trackIfNeeded(eventName, eventData, opt);
            }
            else {
                track(eventsNameTrack[eventName]);
            }
        }, defaultTimer);
        return [key, method];
    })
        .reduce(function (acc, _a) {
        var _b;
        var key = _a[0], value = _a[1];
        return (__assign(__assign({}, acc), (_b = {}, _b[key] = value, _b)));
    }, {});
    var tracker = __assign({ track: track, getCurrentEventsState: getCurrentEventsState, setNavigationContext: function (_a) {
            var context = _a.context, runtimeSettings = _a.runtimeSettings;
            setNavigationUser(context.globalStateManager);
            setUtmNavigationContext(context.utmStateManager);
            setVendor();
            setBaseUri();
            setRecoveryUrl();
            setOnsiteVersion(runtimeSettings.version);
        }, setCustomUrl: setCustomUrl }, trackerEventMethods);

    var context = undefined;
    var api = undefined;
    function setContext(ctx) {
        if (!ctx) {
            return;
        }
        onsiteCore.context = context = ctx;
    }
    var bootstrap$1 = function (settings, context) {
        var _a;
        if (!settings) {
            LOG.warn('Onsite not initialized. Missing initial global settings "window.MailbizOnsite".');
            return;
        }
        setContext(context);
        onsiteCore.api = api = new CoreApi(onsiteCore);
        var trackerFeature = (_a = settings === null || settings === void 0 ? void 0 : settings.features) === null || _a === void 0 ? void 0 : _a.tracker;
        if (typeof trackerFeature === 'object' && (trackerFeature === null || trackerFeature === void 0 ? void 0 : trackerFeature.enabled)) {
            bootstrapTracker({
                appId: settings.app_id,
                scriptUrl: trackerFeature.scriptUrl,
                collectUrl: trackerFeature.apiUrl,
                heartbeatDelay: trackerFeature.pagePingDelay || 0,
            });
        }
    };
    var onsiteCore = {
        $: function () { var _a; return (_a = window._mbz_) === null || _a === void 0 ? void 0 : _a.$; },
        context: context,
        bootstrap: bootstrap$1,
        tracker: tracker,
        api: api,
    };

    var VendorBase = /** @class */ (function () {
        function VendorBase() {
            this.init = false;
            this.onsiteSettings = undefined;
            this.core = undefined;
            this.runtimeSettings = undefined;
        }
        VendorBase.prototype.bootstrap = function (onsiteCore) {
            var _a, _b, _c, _d;
            if (this.init) {
                LOG.debug('Vendor already initialized');
                return;
            }
            if (!onsiteCore) {
                LOG.warn('Onsite not initialized. Missing initial OnsiteCore data.');
                return;
            }
            this.onsiteSettings = window.MailbizOnsite;
            if (!this.onsiteSettings || typeof this.onsiteSettings !== 'object') {
                LOG.warn('Onsite not initialized. Var "window.MailbizOnsite" was not defined');
                return;
            }
            if (!this.onsiteSettings.app_id) {
                LOG.warn('Onsite not initialized. Missing "app_id" parameter.');
                return;
            }
            if (typeof this.shouldBootstrapVendor === 'function' && !this.shouldBootstrapVendor()) {
                // Log inside shouldBootstrapVendor of each vendor
                return;
            }
            this.core = onsiteCore;
            var oneWeek = 7 * 24 * 60 * 60;
            var onsiteCoreContext = {
                globalStateManager: new StorageFactory("tracker_c_" + this.onsiteSettings.app_id),
                utmStateManager: new StorageFactory("tracker_u_" + this.onsiteSettings.app_id, oneWeek),
            };
            onsiteCore.bootstrap(this.onsiteSettings, onsiteCoreContext);
            // Only init features after all bootstraps
            if (((_b = (_a = this.onsiteSettings.features) === null || _a === void 0 ? void 0 : _a.cartRecovery) === null || _b === void 0 ? void 0 : _b.enabled) && this.bootstrapVendorCartRecovery) {
                this.bootstrapVendorCartRecovery(this);
            }
            if (((_d = (_c = this.onsiteSettings.features) === null || _c === void 0 ? void 0 : _c.tracker) === null || _d === void 0 ? void 0 : _d.enabled) && this.bootstrapVendorTracker) {
                onsiteCore.tracker.setNavigationContext({
                    context: onsiteCoreContext,
                    runtimeSettings: this.runtimeSettings,
                });
                if (this.shouldTrackPageView()) {
                    onsiteCore.tracker.pageView();
                }
                this.bootstrapVendorTracker(this);
            }
            this.init = true;
        };
        return VendorBase;
    }());

    var OrderIds = {
        TEMPORARY: '', // Empty string order id is used for temporary orders
    };

    var InterceptionSchedule;
    (function (InterceptionSchedule) {
        InterceptionSchedule["BEFORE"] = "BEFORE";
        InterceptionSchedule["AFTER"] = "AFTER";
    })(InterceptionSchedule || (InterceptionSchedule = {}));
    //#endregion
    var XMLHttpRequestReadyState;
    (function (XMLHttpRequestReadyState) {
        XMLHttpRequestReadyState[XMLHttpRequestReadyState["UNSENT"] = 0] = "UNSENT";
        XMLHttpRequestReadyState[XMLHttpRequestReadyState["OPENED"] = 1] = "OPENED";
        XMLHttpRequestReadyState[XMLHttpRequestReadyState["HEADERS_RECEIVED"] = 2] = "HEADERS_RECEIVED";
        XMLHttpRequestReadyState[XMLHttpRequestReadyState["LOADING"] = 3] = "LOADING";
        XMLHttpRequestReadyState[XMLHttpRequestReadyState["DONE"] = 4] = "DONE";
    })(XMLHttpRequestReadyState || (XMLHttpRequestReadyState = {}));

    var cartRecoveryLoadingTemplate = "<div data-mbz-cr-loading>\n    <style>\n    [data-mbz-cr-loading] {\n        position: fixed;\n        display: flex;\n        align-items: center;\n        flex-direction: column;\n        justify-content: center;\n        top: 0;\n        width: 100%;\n        background: #00000054;\n        height: 100%;\n        z-index: 99999;\n    }\n    .mbz-cr-loading-content {\n        position: relative;\n        width: 480px;\n        height: 280px;\n        display: flex;\n        align-items: center;\n        flex-direction: column;\n        justify-content: center;\n        background: #fff;\n        border: 1px solid #EAEAEA;\n        border-radius: 5px;\n        margin: 16px;\n        padding: 40px;\n    }\n    .mbz-lds-ring {\n        display: block;\n        position: relative;\n        width: 50px;\n        height: 50px;\n        margin: 0 auto;\n    }\n    .mbz-lds-ring div {\n        box-sizing: border-box;\n        display: block;\n        position: absolute;\n        width: 40px;\n        height: 40px;\n        margin: 4px;\n        border: 4px solid #999999;\n        border-radius: 50%;\n        animation: mbz-lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;\n        border-color: #999999 transparent transparent transparent;\n    }\n    .mbz-lds-ring div:nth-child(1) {\n        animation-delay: -0.45s;\n    }\n    .mbz-lds-ring div:nth-child(2) {\n        animation-delay: -0.3s;\n    }\n    .mbz-lds-ring div:nth-child(3) {\n        animation-delay: -0.15s;\n    }\n    @keyframes mbz-lds-ring {\n        0% {\n        transform: rotate(0deg);\n        }\n        100% {\n        transform: rotate(360deg);\n        }\n    }\n\n    .mbz-cr-loader {\n        width: 100%;\n    }\n\n    .mbz-cr-loading-txt {\n        padding-top: 8px;\n        text-align: center;\n        display: block;\n    }\n    @media only screen and (max-width: 512px) {\n        .mbz-cr-loading-content {\n        width: calc(100% - 32px);\n        }\n    }\n    </style>\n\n    <div class=\"mbz-cr-loading-content\">\n    <div class=\"mbz-cr-loader\"><div class=\"mbz-lds-ring\"><div></div><div></div><div></div><div></div></div></div>\n    <span class=\"mbz-cr-loading-txt\">Aguarde um momento...</span>\n    </div>\n</div>\n";

    function getRecoveryDataFromQuery(appId) {
        var queryParams = Url.getQueryParameters();
        var cr = queryParams._mb_cr_, utm = queryParams.utm_source;
        if (!cr || !utm || utm.toLowerCase().indexOf('mailbiz') === -1) {
            return {};
        }
        var cartRecoveryObjectHash;
        try {
            var crHash = base64ToString(cr);
            cartRecoveryObjectHash = JSON.parse(crHash);
            if (!(cartRecoveryObjectHash === null || cartRecoveryObjectHash === void 0 ? void 0 : cartRecoveryObjectHash.c) ||
                !(cartRecoveryObjectHash === null || cartRecoveryObjectHash === void 0 ? void 0 : cartRecoveryObjectHash.t) ||
                !(cartRecoveryObjectHash === null || cartRecoveryObjectHash === void 0 ? void 0 : cartRecoveryObjectHash.u) ||
                !(cartRecoveryObjectHash === null || cartRecoveryObjectHash === void 0 ? void 0 : cartRecoveryObjectHash.its) ||
                !(cartRecoveryObjectHash === null || cartRecoveryObjectHash === void 0 ? void 0 : cartRecoveryObjectHash.its.length) ||
                !appId ||
                appId !== cartRecoveryObjectHash.t) {
                return {};
            }
        }
        catch (ex) {
            LOG.error(ex);
        }
        return {
            hash: cr,
            model: cartRecoveryObjectHash,
        };
    }
    function showRedirectLoading($d) {
        $d.ready(function () {
            window.document.body.insertAdjacentHTML('beforeend', cartRecoveryLoadingTemplate);
            setTimeout(function () {
                $d('[data-mbz-cr-loading] .mbz-cr-loading-txt').html('Estamos verificando o estoque...');
            }, 1000);
        });
    }
    function removeRedirectLoading($d) {
        $d.ready(function () {
            $d('[data-mbz-cr-loading]').remove();
        });
    }
    function redirectToRecoveryUrlIfNeeded() {
        var _a, _b;
        var recoveryUrl = fixUrlIfNeeded((_a = window.MailbizOnsite.features.cartRecovery) === null || _a === void 0 ? void 0 : _a.recoveryUrl);
        if (!recoveryUrl) {
            return;
        }
        var currentUrlWithoutQueryString = fixUrlIfNeeded("" + window.location.origin + window.location.pathname);
        if (recoveryUrl === currentUrlWithoutQueryString) {
            return;
        }
        var redirectedParameterName = 'mbz_redirected';
        var alreadyRedirected = (_b = Url.getQueryParameters()) === null || _b === void 0 ? void 0 : _b[redirectedParameterName];
        if (alreadyRedirected) {
            return;
        }
        var currentSearch = window.location.search;
        var separator = currentSearch.indexOf('?') !== -1 ? '&' : '?';
        var redirectedParameter = redirectedParameterName + "=1";
        var currentSearchWithRedirectedParameter = "" + currentSearch + separator + redirectedParameter;
        window.location.replace("" + recoveryUrl + currentSearchWithRedirectedParameter);
    }

    var SupportedEventsForRecordingEnum;
    (function (SupportedEventsForRecordingEnum) {
        SupportedEventsForRecordingEnum["cartSync"] = "cartSync";
        SupportedEventsForRecordingEnum["accountSync"] = "accountSync";
        SupportedEventsForRecordingEnum["checkoutStep"] = "checkoutStep";
        SupportedEventsForRecordingEnum["orderComplete"] = "orderComplete";
        SupportedEventsForRecordingEnum["productView"] = "productView";
        SupportedEventsForRecordingEnum["cartSetPostalCode"] = "cartSetPostalCode";
        SupportedEventsForRecordingEnum["cartSetCoupon"] = "cartSetCoupon";
        SupportedEventsForRecordingEnum["addToCart;"] = "addToCart";
    })(SupportedEventsForRecordingEnum || (SupportedEventsForRecordingEnum = {}));
    var initialRecordStorage = {
        // Cart
        cart_id: undefined,
        // Variations
        variations: {},
        // Account
        users: [],
        // Cart / Order (generics)
        address: undefined,
        subtotal: -1,
        freight: -1,
        currency: undefined,
        tax: -1,
        coupons: undefined,
        discounts: -1,
        total: -1,
        // Cart Items
        cartSkus: [],
        // Orders
        orders: {},
    };
    var RecordManager = /** @class */ (function () {
        function RecordManager(appId, oldSalt, newSalt) {
            if (oldSalt === void 0) { oldSalt = ''; }
            if (newSalt === void 0) { newSalt = ''; }
            if (oldSalt !== newSalt) {
                new StorageFactory("tracker_v" + oldSalt + "_record_" + appId).remove();
            }
            this.storageManager = new StorageFactory("tracker_v" + newSalt + "_record_" + appId);
        }
        RecordManager.prototype.getStorage = function () {
            return __assign(__assign({}, initialRecordStorage), this.storageManager.get(__assign(__assign({}, initialRecordStorage), { variations: {}, users: [], cartSkus: [], orders: {} }), true));
        };
        RecordManager.prototype.setStorage = function (data) {
            this.storageManager.set(data);
        };
        RecordManager.prototype.stripUndefinedNull = function (obj) {
            for (var key in obj) {
                // Double equals null checks for undefined and null, letting other falsy values pass, like 0 and ""
                if (obj[key] == null) {
                    delete obj[key];
                }
            }
            return obj;
        };
        RecordManager.prototype.firstValid = function () {
            var values = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                values[_i] = arguments[_i];
            }
            // Double equals null checks for undefined and null, letting other falsy values pass, like 0 and ""
            return values.find(function (v) { return v != null; });
        };
        // Provide an event and get missing data filled in. Missing is a property that is undefined, null or simply missing in the object.
        // Only the last version of relevant data will be enriched.
        // If you don't want some data to be enriched, it needs to be passed in. It can't be undefined or null, which is enriched.
        // e.g.: send -1 for subtotal, send "" for coupons, [] for items, {} for address and so on.
        RecordManager.prototype.enrichEvent = function (event, eventData) {
            try {
                switch (event) {
                    case Events.cartSync:
                        return this.enrichCartSync(eventData);
                    case Events.accountSync:
                        return this.enrichAccountSync(eventData);
                    case Events.checkoutStep:
                        return this.enrichCheckoutStep(eventData);
                    case Events.orderComplete:
                        return this.enrichOrderComplete(eventData);
                    case Events.productView:
                        return this.enrichProductView(eventData);
                    case Events.cartSetPostalCode:
                        return this.enrichCartSetPostalCode(eventData);
                    case Events.cartSetCoupon:
                        return this.enrichCartSetCoupon(eventData);
                    case Events.addToCart:
                        return this.enrichAddToCart(eventData);
                    default:
                        throw new Error("enrichEvent: Event " + event + " not supported");
                }
            }
            catch (ex) {
                LOG.error(ex);
                return eventData;
            }
        };
        //#region [Variations]
        //
        // Variations
        //
        RecordManager.prototype.enrichStorageVariations = function (storageVariations, items) {
            var _this = this;
            var _a;
            storageVariations = storageVariations || {};
            // Make items into enriched variations
            (_a = items === null || items === void 0 ? void 0 : items.filter(function (i) { return !!i.sku; })) === null || _a === void 0 ? void 0 : _a.forEach(function (item) {
                var _a;
                var variation = (_a = storageVariations === null || storageVariations === void 0 ? void 0 : storageVariations[item.sku]) !== null && _a !== void 0 ? _a : {};
                variation.stock = _this.firstValid(item === null || item === void 0 ? void 0 : item.stock, variation === null || variation === void 0 ? void 0 : variation.stock);
                variation.available = _this.firstValid(item === null || item === void 0 ? void 0 : item.available, variation === null || variation === void 0 ? void 0 : variation.available);
                variation.quantity = _this.firstValid(item === null || item === void 0 ? void 0 : item.quantity, variation === null || variation === void 0 ? void 0 : variation.quantity);
                variation.product_id = _this.firstValid(item === null || item === void 0 ? void 0 : item.product_id, variation === null || variation === void 0 ? void 0 : variation.product_id);
                variation.category = _this.firstValid(item === null || item === void 0 ? void 0 : item.category, variation === null || variation === void 0 ? void 0 : variation.category);
                variation.brand = _this.firstValid(item === null || item === void 0 ? void 0 : item.brand, variation === null || variation === void 0 ? void 0 : variation.brand);
                variation.sku = _this.firstValid(item === null || item === void 0 ? void 0 : item.sku, variation === null || variation === void 0 ? void 0 : variation.sku);
                variation.name = _this.firstValid(item === null || item === void 0 ? void 0 : item.name, variation === null || variation === void 0 ? void 0 : variation.name);
                variation.price = _this.firstValid(item === null || item === void 0 ? void 0 : item.price, variation === null || variation === void 0 ? void 0 : variation.price);
                variation.price_from = _this.firstValid(item === null || item === void 0 ? void 0 : item.price_from, variation === null || variation === void 0 ? void 0 : variation.price_from);
                variation.image_url = _this.firstValid(item === null || item === void 0 ? void 0 : item.image_url, variation === null || variation === void 0 ? void 0 : variation.image_url);
                variation.url = _this.firstValid(item === null || item === void 0 ? void 0 : item.url, variation === null || variation === void 0 ? void 0 : variation.url);
                variation.properties = _this.firstValid(item === null || item === void 0 ? void 0 : item.properties, variation === null || variation === void 0 ? void 0 : variation.properties);
                variation.recovery_properties = _this.firstValid(item === null || item === void 0 ? void 0 : item.recovery_properties, variation === null || variation === void 0 ? void 0 : variation.recovery_properties);
                variation = _this.stripUndefinedNull(variation);
                storageVariations[item.sku] = variation;
            });
            return storageVariations;
        };
        RecordManager.prototype.getCartItemFromStorageVariation = function (variation) {
            var item = {};
            // stock is not allowed in cart item events
            // available is not allowed in cart item events
            item.quantity = variation.quantity;
            item.product_id = variation.product_id;
            item.category = variation.category;
            item.brand = variation.brand;
            item.sku = variation.sku;
            item.name = variation.name;
            item.price = variation.price;
            item.price_from = variation.price_from;
            item.image_url = variation.image_url;
            item.url = variation.url;
            item.properties = variation.properties;
            item.recovery_properties = variation.recovery_properties;
            return this.stripUndefinedNull(item);
        };
        RecordManager.prototype.getOrderItemFromStorageVariation = function (variation) {
            var item = {};
            // stock is not allowed in cart item events
            // available is not allowed in cart item events
            item.quantity = variation.quantity;
            item.product_id = variation.product_id;
            item.category = variation.category;
            item.brand = variation.brand;
            item.sku = variation.sku;
            item.name = variation.name;
            item.price = variation.price;
            item.price_from = variation.price_from;
            item.image_url = variation.image_url;
            item.url = variation.url;
            item.properties = variation.properties;
            // recovery_properties is not needed in order.complete
            return this.stripUndefinedNull(item);
        };
        RecordManager.prototype.getProductItemFromStorageVariation = function (variation) {
            var item = {};
            item.stock = variation.stock;
            item.available = variation.available;
            // quantity is not allowed in product variant events
            // product_id is not allowed in product variant events
            // category is not allowed in product variant events
            // brand is not allowed in product variant events
            item.sku = variation.sku;
            item.name = variation.name;
            item.price = variation.price;
            item.price_from = variation.price_from;
            item.image_url = variation.image_url;
            item.url = variation.url;
            item.properties = variation.properties;
            item.recovery_properties = variation.recovery_properties;
            return this.stripUndefinedNull(item);
        };
        //#endregion
        //#region [Cart Sync]
        //
        // Cart Sync
        //
        RecordManager.prototype.enrichCartSync = function (cartSyncEvent) {
            var _this = this;
            var _a, _b, _c, _d, _e, _f, _g;
            var storage = this.getStorage();
            var cart = (_a = cartSyncEvent === null || cartSyncEvent === void 0 ? void 0 : cartSyncEvent.cart) !== null && _a !== void 0 ? _a : {};
            // Props
            storage.cart_id = cart.cart_id = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.cart_id, storage === null || storage === void 0 ? void 0 : storage.cart_id);
            storage.address = cart.delivery_address = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.delivery_address, storage === null || storage === void 0 ? void 0 : storage.address);
            storage.subtotal = cart.subtotal = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.subtotal, storage === null || storage === void 0 ? void 0 : storage.subtotal);
            storage.freight = cart.freight = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.freight, storage === null || storage === void 0 ? void 0 : storage.freight);
            storage.currency = cart.currency = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.currency, storage === null || storage === void 0 ? void 0 : storage.currency);
            storage.tax = cart.tax = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.tax, storage === null || storage === void 0 ? void 0 : storage.tax);
            storage.coupons = cart.coupons = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.coupons, storage === null || storage === void 0 ? void 0 : storage.coupons);
            storage.discounts = cart.discounts = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.discounts, storage === null || storage === void 0 ? void 0 : storage.discounts);
            storage.total = cart.total = this.firstValid(cart === null || cart === void 0 ? void 0 : cart.total, storage === null || storage === void 0 ? void 0 : storage.total);
            // Items
            if (!(cart === null || cart === void 0 ? void 0 : cart.items) && ((_b = storage === null || storage === void 0 ? void 0 : storage.cartSkus) === null || _b === void 0 ? void 0 : _b.length)) {
                cart.items = storage.cartSkus.map(function (sku) { return ({ sku: sku }); });
            }
            else {
                storage.cartSkus = (_e = (_d = (_c = cart === null || cart === void 0 ? void 0 : cart.items) === null || _c === void 0 ? void 0 : _c.filter(function (item) { return !!item.sku; })) === null || _d === void 0 ? void 0 : _d.map(function (item) { return item.sku; })) !== null && _e !== void 0 ? _e : [];
            }
            // Variations
            // Make CartItems into StorageVariations
            storage.variations = this.enrichStorageVariations(storage.variations, cart === null || cart === void 0 ? void 0 : cart.items);
            // Extract CartItems items back
            cart.items = (_g = (_f = cart.items) === null || _f === void 0 ? void 0 : _f.map(function (i) { var _a; return (_a = storage.variations[i.sku]) !== null && _a !== void 0 ? _a : i; })) === null || _g === void 0 ? void 0 : _g.map(function (i) { return _this.getCartItemFromStorageVariation(i); });
            // Clean up temporary order complete
            storage.orders[OrderIds.TEMPORARY] = {};
            // Update storage and return
            this.setStorage(storage);
            return { cart: this.stripUndefinedNull(cart) };
        };
        //#endregion
        //#region [Account Sync]
        //
        // Account Sync
        //
        RecordManager.prototype.findUserIndex = function (storageUsers, user) {
            return storageUsers === null || storageUsers === void 0 ? void 0 : storageUsers.findIndex(function (storageUser) {
                return !!(user.user_id && user.user_id === storageUser.user_id) ||
                    !!(user.email && user.email === storageUser.email) ||
                    !!(user.phone && user.phone === storageUser.phone) ||
                    !!(user.name && user.name === storageUser.name);
            });
        };
        RecordManager.prototype.enrichAccountSync = function (accountSyncEvent) {
            var _a, _b, _c;
            var storage = this.getStorage();
            storage.users = (_a = storage.users) !== null && _a !== void 0 ? _a : [];
            var user = (_b = accountSyncEvent === null || accountSyncEvent === void 0 ? void 0 : accountSyncEvent.user) !== null && _b !== void 0 ? _b : {};
            var storageUserIndex = this.findUserIndex(storage.users, user);
            var storageUser = (_c = storage.users[storageUserIndex]) !== null && _c !== void 0 ? _c : {};
            // Props
            storageUser.user_id = user.user_id = this.firstValid(user === null || user === void 0 ? void 0 : user.user_id, storageUser === null || storageUser === void 0 ? void 0 : storageUser.user_id);
            storageUser.email = user.email = this.firstValid(user === null || user === void 0 ? void 0 : user.email, storageUser === null || storageUser === void 0 ? void 0 : storageUser.email);
            storageUser.phone = user.phone = this.firstValid(user === null || user === void 0 ? void 0 : user.phone, storageUser === null || storageUser === void 0 ? void 0 : storageUser.phone);
            storageUser.name = user.name = this.firstValid(user === null || user === void 0 ? void 0 : user.name, storageUser === null || storageUser === void 0 ? void 0 : storageUser.name);
            storageUser.plan = user.plan = this.firstValid(user === null || user === void 0 ? void 0 : user.plan, storageUser === null || storageUser === void 0 ? void 0 : storageUser.plan);
            storageUser.logins = user.logins = this.firstValid(user === null || user === void 0 ? void 0 : user.logins, storageUser === null || storageUser === void 0 ? void 0 : storageUser.logins);
            storageUser.created_at = user.created_at = this.firstValid(user === null || user === void 0 ? void 0 : user.created_at, storageUser === null || storageUser === void 0 ? void 0 : storageUser.created_at);
            // Update storage
            if (Object.keys(storageUser).length > 0) {
                if (storageUserIndex === -1) {
                    storage.users.push(storageUser);
                }
                else {
                    storage.users[storageUserIndex] = storageUser;
                }
                this.setStorage(storage);
            }
            // And return
            this.setStorage(storage);
            return { user: this.stripUndefinedNull(user) };
        };
        //#endregion
        //#region [Checkout Step]
        //
        // Checkout Step
        //
        RecordManager.prototype.enrichCheckoutStep = function (checkoutStepEvent) {
            var _a;
            var storage = this.getStorage();
            var checkout = (_a = checkoutStepEvent === null || checkoutStepEvent === void 0 ? void 0 : checkoutStepEvent.checkout) !== null && _a !== void 0 ? _a : {};
            storage.cart_id = checkout.cart_id = this.firstValid(checkout === null || checkout === void 0 ? void 0 : checkout.cart_id, storage === null || storage === void 0 ? void 0 : storage.cart_id);
            this.setStorage(storage);
            return { checkout: this.stripUndefinedNull(checkoutStepEvent.checkout) };
        };
        //#endregion
        //#region [Order Complete]
        //
        // Order Complete
        //
        RecordManager.prototype.enrichOrderComplete = function (orderCompleteEvent) {
            var _this = this;
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
            var storage = this.getStorage();
            storage.orders = storage.orders || {};
            var order = (_a = orderCompleteEvent === null || orderCompleteEvent === void 0 ? void 0 : orderCompleteEvent.order) !== null && _a !== void 0 ? _a : {};
            var storageOrder = (_c = (_b = storage.orders) === null || _b === void 0 ? void 0 : _b[order === null || order === void 0 ? void 0 : order.order_id]) !== null && _c !== void 0 ? _c : {};
            // Props
            storageOrder.order_id = order.order_id = this.firstValid(order === null || order === void 0 ? void 0 : order.order_id, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.order_id);
            storageOrder.cart_id = order.cart_id = this.firstValid(order === null || order === void 0 ? void 0 : order.cart_id, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.cart_id, storage === null || storage === void 0 ? void 0 : storage.cart_id);
            storageOrder.subtotal = order.subtotal =
                (_d = this.firstValid(order === null || order === void 0 ? void 0 : order.subtotal, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.subtotal, storage === null || storage === void 0 ? void 0 : storage.subtotal)) !== null && _d !== void 0 ? _d : -1;
            storageOrder.freight = order.freight =
                (_e = this.firstValid(order === null || order === void 0 ? void 0 : order.freight, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.freight, storage === null || storage === void 0 ? void 0 : storage.freight)) !== null && _e !== void 0 ? _e : -1;
            storage.currency =
                storageOrder.currency =
                    order.currency =
                        this.firstValid(order === null || order === void 0 ? void 0 : order.currency, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.currency, storage === null || storage === void 0 ? void 0 : storage.currency);
            storageOrder.tax = order.tax = (_f = this.firstValid(order === null || order === void 0 ? void 0 : order.tax, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.tax, storage === null || storage === void 0 ? void 0 : storage.tax)) !== null && _f !== void 0 ? _f : -1;
            storageOrder.discounts = order.discounts =
                (_g = this.firstValid(order === null || order === void 0 ? void 0 : order.discounts, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.discounts, storage === null || storage === void 0 ? void 0 : storage.discounts)) !== null && _g !== void 0 ? _g : -1;
            storageOrder.total = order.total = (_h = this.firstValid(order === null || order === void 0 ? void 0 : order.total, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.total, storage === null || storage === void 0 ? void 0 : storage.total)) !== null && _h !== void 0 ? _h : -1;
            storageOrder.coupons = order.coupons = this.firstValid(order === null || order === void 0 ? void 0 : order.coupons, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.coupons, storage === null || storage === void 0 ? void 0 : storage.coupons);
            storageOrder.payment_methods = order.payment_methods = this.firstValid(order === null || order === void 0 ? void 0 : order.payment_methods, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.payment_methods);
            storageOrder.delivery_methods = order.delivery_methods = this.firstValid(order === null || order === void 0 ? void 0 : order.delivery_methods, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.delivery_methods);
            // items are not recorded this way because it would take up too much storage. we save only the skus in orderSkus
            storage.address =
                storageOrder.delivery_address =
                    order.delivery_address =
                        this.firstValid(order === null || order === void 0 ? void 0 : order.delivery_address, storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.delivery_address, storage === null || storage === void 0 ? void 0 : storage.address);
            // Items
            if (!((_j = order.items) === null || _j === void 0 ? void 0 : _j.length) && (((_k = storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.orderSkus) === null || _k === void 0 ? void 0 : _k.length) || ((_l = storage === null || storage === void 0 ? void 0 : storage.cartSkus) === null || _l === void 0 ? void 0 : _l.length))) {
                order.items = this.firstValid((_m = storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.orderSkus) === null || _m === void 0 ? void 0 : _m.map(function (sku) { return ({ sku: sku }); }), (_o = storage === null || storage === void 0 ? void 0 : storage.cartSkus) === null || _o === void 0 ? void 0 : _o.map(function (sku) { return ({ sku: sku }); }));
            }
            storageOrder.orderSkus = this.firstValid((_q = (_p = order === null || order === void 0 ? void 0 : order.items) === null || _p === void 0 ? void 0 : _p.filter(function (i) { return !!i.sku; })) === null || _q === void 0 ? void 0 : _q.map(function (i) { return i.sku; }), storageOrder === null || storageOrder === void 0 ? void 0 : storageOrder.orderSkus);
            // Variations
            // Make OrderItems into StorageVariations
            storage.variations = this.enrichStorageVariations(storage.variations, order === null || order === void 0 ? void 0 : order.items);
            // Extract OrderItems items back
            order.items = (_s = (_r = order.items) === null || _r === void 0 ? void 0 : _r.map(function (i) { var _a; return (_a = storage.variations[i.sku]) !== null && _a !== void 0 ? _a : i; })) === null || _s === void 0 ? void 0 : _s.map(function (i) { return _this.getOrderItemFromStorageVariation(i); });
            // Storage logic
            // After an order is complete, the cart is empty, we no longer wish to recover several generic properties. Also,
            // if necessary for a second order.complete event of the same id, the data is recorded inside the storageOrder
            storage.cart_id = initialRecordStorage.cart_id;
            storage.cartSkus = [];
            storage.total = initialRecordStorage.total;
            storage.subtotal = initialRecordStorage.subtotal;
            storage.freight = initialRecordStorage.freight;
            storage.discounts = initialRecordStorage.discounts;
            storage.tax = initialRecordStorage.tax;
            storage.coupons = initialRecordStorage.coupons;
            // Update storage and return
            if (order.order_id) {
                storage.orders[order.order_id] = this.stripUndefinedNull(storageOrder);
            }
            this.setStorage(storage);
            return { order: this.stripUndefinedNull(order) };
        };
        //#endregion
        //#region [Product View]
        //
        // Product View
        //
        RecordManager.prototype.enrichProductView = function (productViewEvent) {
            var _this = this;
            var _a, _b, _c, _d, _e, _f;
            var storage = this.getStorage();
            storage.variations = storage.variations || {};
            var product = (_a = productViewEvent === null || productViewEvent === void 0 ? void 0 : productViewEvent.product) !== null && _a !== void 0 ? _a : {};
            var productViewLooseProps = ['brand', 'category', 'url', 'product_id'];
            // Variations
            // Make ProductItems into StorageVariations
            storage.variations = this.enrichStorageVariations(storage.variations, (_b = product === null || product === void 0 ? void 0 : product.variants) === null || _b === void 0 ? void 0 : _b.map(function (v) {
                productViewLooseProps.forEach(function (prop) {
                    if (prop === 'url') {
                        // Url has this specific logic in which a product url shouldn't overwrite a variation url
                        product[prop] && !v[prop] && (v[prop] = product[prop]);
                    }
                    else {
                        product[prop] && (v[prop] = product[prop]);
                    }
                });
                return v;
            }));
            // Extract ProductItems items back
            product.variants = (_d = (_c = product === null || product === void 0 ? void 0 : product.variants) === null || _c === void 0 ? void 0 : _c.map(function (v) { var _a; return (_a = storage.variations[v.sku]) !== null && _a !== void 0 ? _a : v; })) === null || _d === void 0 ? void 0 : _d.map(function (v) { return _this.getProductItemFromStorageVariation(v); });
            // Props
            var missingProps = productViewLooseProps.filter(function (prop) { return !product[prop]; });
            // Fill in props that are missing from product, but are present in variations
            if (missingProps.length) {
                var _loop_1 = function (i) {
                    var variant = product.variants[i];
                    missingProps.forEach(function (missingProp) {
                        var _a, _b;
                        // Get the data from the enriched variations, from storage
                        var prop = (_b = (_a = storage.variations) === null || _a === void 0 ? void 0 : _a[variant.sku]) === null || _b === void 0 ? void 0 : _b[missingProp];
                        if (prop) {
                            product[missingProp] = prop;
                        }
                    });
                };
                // Use only the variations from this event, which should be all the variations of the product
                for (var i = 0; i < ((_f = (_e = product === null || product === void 0 ? void 0 : product.variants) === null || _e === void 0 ? void 0 : _e.length) !== null && _f !== void 0 ? _f : 0); i++) {
                    _loop_1(i);
                }
            }
            // Update storage and return
            this.setStorage(storage);
            return { product: this.stripUndefinedNull(product) };
        };
        //#endregion
        //#region [Cart PostalCode]
        //
        // PostalCode
        //
        RecordManager.prototype.enrichCartSetPostalCode = function (postalCodeEvent) {
            var _a, _b, _c;
            var storage = this.getStorage();
            // Cart Id
            storage.cart_id = postalCodeEvent.cart_id = this.firstValid(postalCodeEvent.cart_id, storage.cart_id);
            // Postal and and address
            var cleanStoragePostalCode = (_b = (_a = storage === null || storage === void 0 ? void 0 : storage.address) === null || _a === void 0 ? void 0 : _a.postal_code) === null || _b === void 0 ? void 0 : _b.replace(/\D/g, '');
            var cleanPostalCode = (_c = postalCodeEvent === null || postalCodeEvent === void 0 ? void 0 : postalCodeEvent.postal_code) === null || _c === void 0 ? void 0 : _c.replace(/\D/g, '');
            // Storage logic
            // If postal code changed the address is no longer valid
            var postalCodeChanged = cleanPostalCode && cleanPostalCode !== cleanStoragePostalCode;
            if (postalCodeChanged) {
                storage.address = {
                    postal_code: postalCodeEvent.postal_code,
                };
            }
            // Update storage and return
            this.setStorage(storage);
            return this.stripUndefinedNull(postalCodeEvent);
        };
        //#endregion
        //#region [Cart Coupon]
        //
        // Coupon
        //
        RecordManager.prototype.enrichCartSetCoupon = function (couponEvent) {
            var storage = this.getStorage();
            storage.cart_id = couponEvent.cart_id = this.firstValid(couponEvent.cart_id, storage.cart_id);
            storage.coupons = couponEvent.coupon = this.firstValid(couponEvent.coupon, storage.coupons);
            // Update storage and return
            this.setStorage(storage);
            return this.stripUndefinedNull(couponEvent);
        };
        //#endregion
        //#region [Add To Cart]
        RecordManager.prototype.enrichAddToCart = function (addToCartEvent) {
            var _this = this;
            var _a, _b;
            var storage = this.getStorage();
            storage.variations = storage.variations || [];
            // Variations
            // Make CartItems into StorageVariations
            storage.variations = this.enrichStorageVariations(storage.variations, addToCartEvent === null || addToCartEvent === void 0 ? void 0 : addToCartEvent.products);
            // Extract CartItems items back
            addToCartEvent.products = (_b = (_a = addToCartEvent === null || addToCartEvent === void 0 ? void 0 : addToCartEvent.products) === null || _a === void 0 ? void 0 : _a.map(function (i) { var _a; return (_a = storage.variations[i.sku]) !== null && _a !== void 0 ? _a : i; })) === null || _b === void 0 ? void 0 : _b.map(function (i) { return _this.getCartItemFromStorageVariation(i); });
            if (!addToCartEvent.products) {
                return {};
            }
            // Update storage and return
            this.setStorage(storage);
            return addToCartEvent;
        };
        return RecordManager;
    }());

    function isFunction(val) {
        return !!val && typeof val === 'function';
    }

    var $d$1;
    //#region [Recovery Flow]
    function buildCartRecoveryPayload(data) {
        var _a;
        return {
            cart_id: data.c,
            user_id: data.u,
            products: (_a = data.its) === null || _a === void 0 ? void 0 : _a.map(function (it) { return ({
                product_id: it[1] || '',
                sku: it[2] || '',
                quantity: parseInt(it[0]) || 1,
                recovery_properties: tryToParseJson(it[3] || '') || {},
            }); }),
        };
    }
    //#endregion
    //#region [Bootstrap]
    function validateBootstrap$1(appId) {
        var warn;
        var error;
        if (!$d$1) {
            warn = 'Universal: DomHelper not found';
        }
        if (!appId) {
            error = 'Universal: invalid appId';
        }
        warn && LOG.warn(warn);
        error && LOG.error(error);
        return !warn && !error;
    }
    function bootstrapVendorCartRecovery(vendorInstance) {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, void 0, function () {
            var appId, recoveryDataFromQuery, cartRecoveryObject, hash, recoveryAction;
            return __generator(this, function (_e) {
                appId = ((_a = vendorInstance.onsiteSettings) === null || _a === void 0 ? void 0 : _a.app_id) || '';
                $d$1 = (_b = window === null || window === void 0 ? void 0 : window._mbz_) === null || _b === void 0 ? void 0 : _b.$;
                if (!validateBootstrap$1(appId)) {
                    LOG.debug("Universal: didn't validate bootstrap");
                    return [2 /*return*/];
                }
                recoveryDataFromQuery = (_c = getRecoveryDataFromQuery(appId)) !== null && _c !== void 0 ? _c : {};
                cartRecoveryObject = recoveryDataFromQuery.model, hash = recoveryDataFromQuery.hash;
                if (!cartRecoveryObject || !hash || !(((_d = cartRecoveryObject === null || cartRecoveryObject === void 0 ? void 0 : cartRecoveryObject.its) === null || _d === void 0 ? void 0 : _d.length) > 0)) {
                    LOG.debug('Universal: recovery object / hash is empty, should not recover');
                    return [2 /*return*/];
                }
                LOG.debug('Universal: CartRecoveryObject', cartRecoveryObject);
                redirectToRecoveryUrlIfNeeded();
                if (!isFunction(window.mb_recover_cart)) {
                    LOG.warn('Universal: global method "mb_recover_cart" not defined');
                }
                recoveryAction = window.mb_recover_cart;
                try {
                    showRedirectLoading($d$1);
                    setTimeout(function () { return recoveryAction(buildCartRecoveryPayload(cartRecoveryObject)); }, 10);
                    setTimeout(function () { return removeRedirectLoading($d$1); }, 10);
                }
                catch (e) {
                    LOG.error('Universal: error while recovering cart', e);
                }
                return [2 /*return*/];
            });
        });
    }
    //#endregion

    /**
     * Based on Kendo UI Core expression code <https://github.com/telerik/kendo-ui-core#license-information>
     */

    function Cache(maxSize) {
      this._maxSize = maxSize;
      this.clear();
    }
    Cache.prototype.clear = function () {
      this._size = 0;
      this._values = Object.create(null);
    };
    Cache.prototype.get = function (key) {
      return this._values[key]
    };
    Cache.prototype.set = function (key, value) {
      this._size >= this._maxSize && this.clear();
      if (!(key in this._values)) this._size++;

      return (this._values[key] = value)
    };

    var SPLIT_REGEX = /[^.^\]^[]+|(?=\[\]|\.\.)/g,
      DIGIT_REGEX = /^\d+$/,
      LEAD_DIGIT_REGEX = /^\d/,
      SPEC_CHAR_REGEX = /[~`!#$%\^&*+=\-\[\]\\';,/{}|\\":<>\?]/g,
      CLEAN_QUOTES_REGEX = /^\s*(['"]?)(.*?)(\1)\s*$/,
      MAX_CACHE_SIZE = 512;

    var pathCache = new Cache(MAX_CACHE_SIZE),
      setCache = new Cache(MAX_CACHE_SIZE),
      getCache = new Cache(MAX_CACHE_SIZE);

    var propertyExpr = {
      Cache: Cache,

      split: split,

      normalizePath: normalizePath,

      setter: function (path) {
        var parts = normalizePath(path);

        return (
          setCache.get(path) ||
          setCache.set(path, function setter(obj, value) {
            var index = 0;
            var len = parts.length;
            var data = obj;

            while (index < len - 1) {
              var part = parts[index];
              if (
                part === '__proto__' ||
                part === 'constructor' ||
                part === 'prototype'
              ) {
                return obj
              }

              data = data[parts[index++]];
            }
            data[parts[index]] = value;
          })
        )
      },

      getter: function (path, safe) {
        var parts = normalizePath(path);
        return (
          getCache.get(path) ||
          getCache.set(path, function getter(data) {
            var index = 0,
              len = parts.length;
            while (index < len) {
              if (data != null || !safe) data = data[parts[index++]];
              else return
            }
            return data
          })
        )
      },

      join: function (segments) {
        return segments.reduce(function (path, part) {
          return (
            path +
            (isQuoted(part) || DIGIT_REGEX.test(part)
              ? '[' + part + ']'
              : (path ? '.' : '') + part)
          )
        }, '')
      },

      forEach: function (path, cb, thisArg) {
        forEach(Array.isArray(path) ? path : split(path), cb, thisArg);
      },
    };

    function normalizePath(path) {
      return (
        pathCache.get(path) ||
        pathCache.set(
          path,
          split(path).map(function (part) {
            return part.replace(CLEAN_QUOTES_REGEX, '$2')
          })
        )
      )
    }

    function split(path) {
      return path.match(SPLIT_REGEX) || ['']
    }

    function forEach(parts, iter, thisArg) {
      var len = parts.length,
        part,
        idx,
        isArray,
        isBracket;

      for (idx = 0; idx < len; idx++) {
        part = parts[idx];

        if (part) {
          if (shouldBeQuoted(part)) {
            part = '"' + part + '"';
          }

          isBracket = isQuoted(part);
          isArray = !isBracket && /^\d+$/.test(part);

          iter.call(thisArg, part, isBracket, isArray, idx, parts);
        }
      }
    }

    function isQuoted(str) {
      return (
        typeof str === 'string' && str && ["'", '"'].indexOf(str.charAt(0)) !== -1
      )
    }

    function hasLeadingNumber(part) {
      return part.match(LEAD_DIGIT_REGEX) && !part.match(DIGIT_REGEX)
    }

    function hasSpecialChars(part) {
      return SPEC_CHAR_REGEX.test(part)
    }

    function shouldBeQuoted(part) {
      return !isQuoted(part) && (hasLeadingNumber(part) || hasSpecialChars(part))
    }

    const reWords = /[A-Z\xc0-\xd6\xd8-\xde]?[a-z\xdf-\xf6\xf8-\xff]+(?:['’](?:d|ll|m|re|s|t|ve))?(?=[\xac\xb1\xd7\xf7\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\xbf\u2000-\u206f \t\x0b\f\xa0\ufeff\n\r\u2028\u2029\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000]|[A-Z\xc0-\xd6\xd8-\xde]|$)|(?:[A-Z\xc0-\xd6\xd8-\xde]|[^\ud800-\udfff\xac\xb1\xd7\xf7\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\xbf\u2000-\u206f \t\x0b\f\xa0\ufeff\n\r\u2028\u2029\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\d+\u2700-\u27bfa-z\xdf-\xf6\xf8-\xffA-Z\xc0-\xd6\xd8-\xde])+(?:['’](?:D|LL|M|RE|S|T|VE))?(?=[\xac\xb1\xd7\xf7\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\xbf\u2000-\u206f \t\x0b\f\xa0\ufeff\n\r\u2028\u2029\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000]|[A-Z\xc0-\xd6\xd8-\xde](?:[a-z\xdf-\xf6\xf8-\xff]|[^\ud800-\udfff\xac\xb1\xd7\xf7\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\xbf\u2000-\u206f \t\x0b\f\xa0\ufeff\n\r\u2028\u2029\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\d+\u2700-\u27bfa-z\xdf-\xf6\xf8-\xffA-Z\xc0-\xd6\xd8-\xde])|$)|[A-Z\xc0-\xd6\xd8-\xde]?(?:[a-z\xdf-\xf6\xf8-\xff]|[^\ud800-\udfff\xac\xb1\xd7\xf7\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\xbf\u2000-\u206f \t\x0b\f\xa0\ufeff\n\r\u2028\u2029\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\d+\u2700-\u27bfa-z\xdf-\xf6\xf8-\xffA-Z\xc0-\xd6\xd8-\xde])+(?:['’](?:d|ll|m|re|s|t|ve))?|[A-Z\xc0-\xd6\xd8-\xde]+(?:['’](?:D|LL|M|RE|S|T|VE))?|\d*(?:1ST|2ND|3RD|(?![123])\dTH)(?=\b|[a-z_])|\d*(?:1st|2nd|3rd|(?![123])\dth)(?=\b|[A-Z_])|\d+|(?:[\u2700-\u27bf]|(?:\ud83c[\udde6-\uddff]){2}|[\ud800-\udbff][\udc00-\udfff])[\ufe0e\ufe0f]?(?:[\u0300-\u036f\ufe20-\ufe2f\u20d0-\u20ff]|\ud83c[\udffb-\udfff])?(?:\u200d(?:[^\ud800-\udfff]|(?:\ud83c[\udde6-\uddff]){2}|[\ud800-\udbff][\udc00-\udfff])[\ufe0e\ufe0f]?(?:[\u0300-\u036f\ufe20-\ufe2f\u20d0-\u20ff]|\ud83c[\udffb-\udfff])?)*/g;

    const words = (str) => str.match(reWords) || [];

    const upperFirst = (str) => str[0].toUpperCase() + str.slice(1);

    const join = (str, d) => words(str).join(d).toLowerCase();

    const camelCase = (str) =>
      words(str).reduce(
        (acc, next) =>
          `${acc}${
        !acc
          ? next.toLowerCase()
          : next[0].toUpperCase() + next.slice(1).toLowerCase()
      }`,
        '',
      );

    const pascalCase = (str) => upperFirst(camelCase(str));

    const snakeCase = (str) => join(str, '_');

    const kebabCase = (str) => join(str, '-');

    const sentenceCase = (str) => upperFirst(join(str, ' '));

    const titleCase = (str) => words(str).map(upperFirst).join(' ');

    var tinyCase = {
      words,
      upperFirst,
      camelCase,
      pascalCase,
      snakeCase,
      kebabCase,
      sentenceCase,
      titleCase,
    };

    /**
     * Topological sorting function
     *
     * @param {Array} edges
     * @returns {Array}
     */

    var toposort_1 = function(edges) {
      return toposort(uniqueNodes(edges), edges)
    };

    var array$1 = toposort;

    function toposort(nodes, edges) {
      var cursor = nodes.length
        , sorted = new Array(cursor)
        , visited = {}
        , i = cursor
        // Better data structures make algorithm much faster.
        , outgoingEdges = makeOutgoingEdges(edges)
        , nodesHash = makeNodesHash(nodes);

      // check for unknown nodes
      edges.forEach(function(edge) {
        if (!nodesHash.has(edge[0]) || !nodesHash.has(edge[1])) {
          throw new Error('Unknown node. There is an unknown node in the supplied edges.')
        }
      });

      while (i--) {
        if (!visited[i]) visit(nodes[i], i, new Set());
      }

      return sorted

      function visit(node, i, predecessors) {
        if(predecessors.has(node)) {
          var nodeRep;
          try {
            nodeRep = ", node was:" + JSON.stringify(node);
          } catch(e) {
            nodeRep = "";
          }
          throw new Error('Cyclic dependency' + nodeRep)
        }

        if (!nodesHash.has(node)) {
          throw new Error('Found unknown node. Make sure to provided all involved nodes. Unknown node: '+JSON.stringify(node))
        }

        if (visited[i]) return;
        visited[i] = true;

        var outgoing = outgoingEdges.get(node) || new Set();
        outgoing = Array.from(outgoing);

        if (i = outgoing.length) {
          predecessors.add(node);
          do {
            var child = outgoing[--i];
            visit(child, nodesHash.get(child), predecessors);
          } while (i)
          predecessors.delete(node);
        }

        sorted[--cursor] = node;
      }
    }

    function uniqueNodes(arr){
      var res = new Set();
      for (var i = 0, len = arr.length; i < len; i++) {
        var edge = arr[i];
        res.add(edge[0]);
        res.add(edge[1]);
      }
      return Array.from(res)
    }

    function makeOutgoingEdges(arr){
      var edges = new Map();
      for (var i = 0, len = arr.length; i < len; i++) {
        var edge = arr[i];
        if (!edges.has(edge[0])) edges.set(edge[0], new Set());
        if (!edges.has(edge[1])) edges.set(edge[1], new Set());
        edges.get(edge[0]).add(edge[1]);
      }
      return edges
    }

    function makeNodesHash(arr){
      var res = new Map();
      for (var i = 0, len = arr.length; i < len; i++) {
        res.set(arr[i], i);
      }
      return res
    }
    toposort_1.array = array$1;

    const toString = Object.prototype.toString;
    const errorToString = Error.prototype.toString;
    const regExpToString = RegExp.prototype.toString;
    const symbolToString = typeof Symbol !== 'undefined' ? Symbol.prototype.toString : () => '';
    const SYMBOL_REGEXP = /^Symbol\((.*)\)(.*)$/;
    function printNumber(val) {
      if (val != +val) return 'NaN';
      const isNegativeZero = val === 0 && 1 / val < 0;
      return isNegativeZero ? '-0' : '' + val;
    }
    function printSimpleValue(val, quoteStrings = false) {
      if (val == null || val === true || val === false) return '' + val;
      const typeOf = typeof val;
      if (typeOf === 'number') return printNumber(val);
      if (typeOf === 'string') return quoteStrings ? `"${val}"` : val;
      if (typeOf === 'function') return '[Function ' + (val.name || 'anonymous') + ']';
      if (typeOf === 'symbol') return symbolToString.call(val).replace(SYMBOL_REGEXP, 'Symbol($1)');
      const tag = toString.call(val).slice(8, -1);
      if (tag === 'Date') return isNaN(val.getTime()) ? '' + val : val.toISOString(val);
      if (tag === 'Error' || val instanceof Error) return '[' + errorToString.call(val) + ']';
      if (tag === 'RegExp') return regExpToString.call(val);
      return null;
    }
    function printValue(value, quoteStrings) {
      let result = printSimpleValue(value, quoteStrings);
      if (result !== null) return result;
      return JSON.stringify(value, function (key, value) {
        let result = printSimpleValue(this[key], quoteStrings);
        if (result !== null) return result;
        return value;
      }, 2);
    }

    function toArray(value) {
      return value == null ? [] : [].concat(value);
    }

    let _Symbol$toStringTag;
    let strReg = /\$\{\s*(\w+)\s*\}/g;
    _Symbol$toStringTag = Symbol.toStringTag;
    class ValidationError extends Error {
      static formatError(message, params) {
        const path = params.label || params.path || 'this';
        if (path !== params.path) params = Object.assign({}, params, {
          path
        });
        if (typeof message === 'string') return message.replace(strReg, (_, key) => printValue(params[key]));
        if (typeof message === 'function') return message(params);
        return message;
      }
      static isError(err) {
        return err && err.name === 'ValidationError';
      }
      constructor(errorOrErrors, value, field, type, disableStack) {
        super();
        this.value = void 0;
        this.path = void 0;
        this.type = void 0;
        this.errors = void 0;
        this.params = void 0;
        this.inner = void 0;
        this[_Symbol$toStringTag] = 'Error';
        this.name = 'ValidationError';
        this.value = value;
        this.path = field;
        this.type = type;
        this.errors = [];
        this.inner = [];
        toArray(errorOrErrors).forEach(err => {
          if (ValidationError.isError(err)) {
            this.errors.push(...err.errors);
            const innerErrors = err.inner.length ? err.inner : [err];
            this.inner.push(...innerErrors);
          } else {
            this.errors.push(err);
          }
        });
        this.message = this.errors.length > 1 ? `${this.errors.length} errors occurred` : this.errors[0];
        if (!disableStack && Error.captureStackTrace) Error.captureStackTrace(this, ValidationError);
      }
    }

    let mixed = {
      default: '${path} is invalid',
      required: '${path} is a required field',
      defined: '${path} must be defined',
      notNull: '${path} cannot be null',
      oneOf: '${path} must be one of the following values: ${values}',
      notOneOf: '${path} must not be one of the following values: ${values}',
      notType: ({
        path,
        type,
        value,
        originalValue
      }) => {
        const castMsg = originalValue != null && originalValue !== value ? ` (cast from the value \`${printValue(originalValue, true)}\`).` : '.';
        return type !== 'mixed' ? `${path} must be a \`${type}\` type, ` + `but the final value was: \`${printValue(value, true)}\`` + castMsg : `${path} must match the configured type. ` + `The validated value was: \`${printValue(value, true)}\`` + castMsg;
      }
    };
    let string = {
      length: '${path} must be exactly ${length} characters',
      min: '${path} must be at least ${min} characters',
      max: '${path} must be at most ${max} characters',
      matches: '${path} must match the following: "${regex}"',
      email: '${path} must be a valid email',
      url: '${path} must be a valid URL',
      uuid: '${path} must be a valid UUID',
      trim: '${path} must be a trimmed string',
      lowercase: '${path} must be a lowercase string',
      uppercase: '${path} must be a upper case string'
    };
    let number = {
      min: '${path} must be greater than or equal to ${min}',
      max: '${path} must be less than or equal to ${max}',
      lessThan: '${path} must be less than ${less}',
      moreThan: '${path} must be greater than ${more}',
      positive: '${path} must be a positive number',
      negative: '${path} must be a negative number',
      integer: '${path} must be an integer'
    };
    let date = {
      min: '${path} field must be later than ${min}',
      max: '${path} field must be at earlier than ${max}'
    };
    let boolean = {
      isValue: '${path} field must be ${value}'
    };
    let object = {
      noUnknown: '${path} field has unspecified keys: ${unknown}'
    };
    let array = {
      min: '${path} field must have at least ${min} items',
      max: '${path} field must have less than or equal to ${max} items',
      length: '${path} must have ${length} items'
    };
    let tuple = {
      notType: params => {
        const {
          path,
          value,
          spec
        } = params;
        const typeLen = spec.types.length;
        if (Array.isArray(value)) {
          if (value.length < typeLen) return `${path} tuple value has too few items, expected a length of ${typeLen} but got ${value.length} for value: \`${printValue(value, true)}\``;
          if (value.length > typeLen) return `${path} tuple value has too many items, expected a length of ${typeLen} but got ${value.length} for value: \`${printValue(value, true)}\``;
        }
        return ValidationError.formatError(mixed.notType, params);
      }
    };
    Object.assign(Object.create(null), {
      mixed,
      string,
      number,
      date,
      object,
      array,
      boolean,
      tuple
    });

    const isSchema = obj => obj && obj.__isYupSchema__;

    class Condition {
      static fromOptions(refs, config) {
        if (!config.then && !config.otherwise) throw new TypeError('either `then:` or `otherwise:` is required for `when()` conditions');
        let {
          is,
          then,
          otherwise
        } = config;
        let check = typeof is === 'function' ? is : (...values) => values.every(value => value === is);
        return new Condition(refs, (values, schema) => {
          var _branch;
          let branch = check(...values) ? then : otherwise;
          return (_branch = branch == null ? void 0 : branch(schema)) != null ? _branch : schema;
        });
      }
      constructor(refs, builder) {
        this.fn = void 0;
        this.refs = refs;
        this.refs = refs;
        this.fn = builder;
      }
      resolve(base, options) {
        let values = this.refs.map(ref =>
        // TODO: ? operator here?
        ref.getValue(options == null ? void 0 : options.value, options == null ? void 0 : options.parent, options == null ? void 0 : options.context));
        let schema = this.fn(values, base, options);
        if (schema === undefined ||
        // @ts-ignore this can be base
        schema === base) {
          return base;
        }
        if (!isSchema(schema)) throw new TypeError('conditions must return a schema object');
        return schema.resolve(options);
      }
    }

    const prefixes = {
      context: '$',
      value: '.'
    };
    class Reference {
      constructor(key, options = {}) {
        this.key = void 0;
        this.isContext = void 0;
        this.isValue = void 0;
        this.isSibling = void 0;
        this.path = void 0;
        this.getter = void 0;
        this.map = void 0;
        if (typeof key !== 'string') throw new TypeError('ref must be a string, got: ' + key);
        this.key = key.trim();
        if (key === '') throw new TypeError('ref must be a non-empty string');
        this.isContext = this.key[0] === prefixes.context;
        this.isValue = this.key[0] === prefixes.value;
        this.isSibling = !this.isContext && !this.isValue;
        let prefix = this.isContext ? prefixes.context : this.isValue ? prefixes.value : '';
        this.path = this.key.slice(prefix.length);
        this.getter = this.path && propertyExpr.getter(this.path, true);
        this.map = options.map;
      }
      getValue(value, parent, context) {
        let result = this.isContext ? context : this.isValue ? value : parent;
        if (this.getter) result = this.getter(result || {});
        if (this.map) result = this.map(result);
        return result;
      }

      /**
       *
       * @param {*} value
       * @param {Object} options
       * @param {Object=} options.context
       * @param {Object=} options.parent
       */
      cast(value, options) {
        return this.getValue(value, options == null ? void 0 : options.parent, options == null ? void 0 : options.context);
      }
      resolve() {
        return this;
      }
      describe() {
        return {
          type: 'ref',
          key: this.key
        };
      }
      toString() {
        return `Ref(${this.key})`;
      }
      static isRef(value) {
        return value && value.__isYupRef;
      }
    }

    // @ts-ignore
    Reference.prototype.__isYupRef = true;

    const isAbsent = value => value == null;

    function createValidation(config) {
      function validate({
        value,
        path = '',
        options,
        originalValue,
        schema
      }, panic, next) {
        const {
          name,
          test,
          params,
          message,
          skipAbsent
        } = config;
        let {
          parent,
          context,
          abortEarly = schema.spec.abortEarly,
          disableStackTrace = schema.spec.disableStackTrace
        } = options;
        function resolve(item) {
          return Reference.isRef(item) ? item.getValue(value, parent, context) : item;
        }
        function createError(overrides = {}) {
          var _overrides$disableSta;
          const nextParams = Object.assign({
            value,
            originalValue,
            label: schema.spec.label,
            path: overrides.path || path,
            spec: schema.spec
          }, params, overrides.params);
          for (const key of Object.keys(nextParams)) nextParams[key] = resolve(nextParams[key]);
          const error = new ValidationError(ValidationError.formatError(overrides.message || message, nextParams), value, nextParams.path, overrides.type || name, (_overrides$disableSta = overrides.disableStackTrace) != null ? _overrides$disableSta : disableStackTrace);
          error.params = nextParams;
          return error;
        }
        const invalid = abortEarly ? panic : next;
        let ctx = {
          path,
          parent,
          type: name,
          from: options.from,
          createError,
          resolve,
          options,
          originalValue,
          schema
        };
        const handleResult = validOrError => {
          if (ValidationError.isError(validOrError)) invalid(validOrError);else if (!validOrError) invalid(createError());else next(null);
        };
        const handleError = err => {
          if (ValidationError.isError(err)) invalid(err);else panic(err);
        };
        const shouldSkip = skipAbsent && isAbsent(value);
        if (shouldSkip) {
          return handleResult(true);
        }
        let result;
        try {
          var _result;
          result = test.call(ctx, value, ctx);
          if (typeof ((_result = result) == null ? void 0 : _result.then) === 'function') {
            if (options.sync) {
              throw new Error(`Validation test of type: "${ctx.type}" returned a Promise during a synchronous validate. ` + `This test will finish after the validate call has returned`);
            }
            return Promise.resolve(result).then(handleResult, handleError);
          }
        } catch (err) {
          handleError(err);
          return;
        }
        handleResult(result);
      }
      validate.OPTIONS = config;
      return validate;
    }

    function getIn(schema, path, value, context = value) {
      let parent, lastPart, lastPartDebug;

      // root path: ''
      if (!path) return {
        parent,
        parentPath: path,
        schema
      };
      propertyExpr.forEach(path, (_part, isBracket, isArray) => {
        let part = isBracket ? _part.slice(1, _part.length - 1) : _part;
        schema = schema.resolve({
          context,
          parent,
          value
        });
        let isTuple = schema.type === 'tuple';
        let idx = isArray ? parseInt(part, 10) : 0;
        if (schema.innerType || isTuple) {
          if (isTuple && !isArray) throw new Error(`Yup.reach cannot implicitly index into a tuple type. the path part "${lastPartDebug}" must contain an index to the tuple element, e.g. "${lastPartDebug}[0]"`);
          if (value && idx >= value.length) {
            throw new Error(`Yup.reach cannot resolve an array item at index: ${_part}, in the path: ${path}. ` + `because there is no value at that index. `);
          }
          parent = value;
          value = value && value[idx];
          schema = isTuple ? schema.spec.types[idx] : schema.innerType;
        }

        // sometimes the array index part of a path doesn't exist: "nested.arr.child"
        // in these cases the current part is the next schema and should be processed
        // in this iteration. For cases where the index signature is included this
        // check will fail and we'll handle the `child` part on the next iteration like normal
        if (!isArray) {
          if (!schema.fields || !schema.fields[part]) throw new Error(`The schema does not contain the path: ${path}. ` + `(failed at: ${lastPartDebug} which is a type: "${schema.type}")`);
          parent = value;
          value = value && value[part];
          schema = schema.fields[part];
        }
        lastPart = part;
        lastPartDebug = isBracket ? '[' + _part + ']' : '.' + _part;
      });
      return {
        schema,
        parent,
        parentPath: lastPart
      };
    }

    class ReferenceSet extends Set {
      describe() {
        const description = [];
        for (const item of this.values()) {
          description.push(Reference.isRef(item) ? item.describe() : item);
        }
        return description;
      }
      resolveAll(resolve) {
        let result = [];
        for (const item of this.values()) {
          result.push(resolve(item));
        }
        return result;
      }
      clone() {
        return new ReferenceSet(this.values());
      }
      merge(newItems, removeItems) {
        const next = this.clone();
        newItems.forEach(value => next.add(value));
        removeItems.forEach(value => next.delete(value));
        return next;
      }
    }

    // tweaked from https://github.com/Kelin2025/nanoclone/blob/0abeb7635bda9b68ef2277093f76dbe3bf3948e1/src/index.js
    function clone(src, seen = new Map()) {
      if (isSchema(src) || !src || typeof src !== 'object') return src;
      if (seen.has(src)) return seen.get(src);
      let copy;
      if (src instanceof Date) {
        // Date
        copy = new Date(src.getTime());
        seen.set(src, copy);
      } else if (src instanceof RegExp) {
        // RegExp
        copy = new RegExp(src);
        seen.set(src, copy);
      } else if (Array.isArray(src)) {
        // Array
        copy = new Array(src.length);
        seen.set(src, copy);
        for (let i = 0; i < src.length; i++) copy[i] = clone(src[i], seen);
      } else if (src instanceof Map) {
        // Map
        copy = new Map();
        seen.set(src, copy);
        for (const [k, v] of src.entries()) copy.set(k, clone(v, seen));
      } else if (src instanceof Set) {
        // Set
        copy = new Set();
        seen.set(src, copy);
        for (const v of src) copy.add(clone(v, seen));
      } else if (src instanceof Object) {
        // Object
        copy = {};
        seen.set(src, copy);
        for (const [k, v] of Object.entries(src)) copy[k] = clone(v, seen);
      } else {
        throw Error(`Unable to clone ${src}`);
      }
      return copy;
    }

    // If `CustomSchemaMeta` isn't extended with any keys, we'll fall back to a
    // loose Record definition allowing free form usage.
    class Schema {
      constructor(options) {
        this.type = void 0;
        this.deps = [];
        this.tests = void 0;
        this.transforms = void 0;
        this.conditions = [];
        this._mutate = void 0;
        this.internalTests = {};
        this._whitelist = new ReferenceSet();
        this._blacklist = new ReferenceSet();
        this.exclusiveTests = Object.create(null);
        this._typeCheck = void 0;
        this.spec = void 0;
        this.tests = [];
        this.transforms = [];
        this.withMutation(() => {
          this.typeError(mixed.notType);
        });
        this.type = options.type;
        this._typeCheck = options.check;
        this.spec = Object.assign({
          strip: false,
          strict: false,
          abortEarly: true,
          recursive: true,
          disableStackTrace: false,
          nullable: false,
          optional: true,
          coerce: true
        }, options == null ? void 0 : options.spec);
        this.withMutation(s => {
          s.nonNullable();
        });
      }

      // TODO: remove
      get _type() {
        return this.type;
      }
      clone(spec) {
        if (this._mutate) {
          if (spec) Object.assign(this.spec, spec);
          return this;
        }

        // if the nested value is a schema we can skip cloning, since
        // they are already immutable
        const next = Object.create(Object.getPrototypeOf(this));

        // @ts-expect-error this is readonly
        next.type = this.type;
        next._typeCheck = this._typeCheck;
        next._whitelist = this._whitelist.clone();
        next._blacklist = this._blacklist.clone();
        next.internalTests = Object.assign({}, this.internalTests);
        next.exclusiveTests = Object.assign({}, this.exclusiveTests);

        // @ts-expect-error this is readonly
        next.deps = [...this.deps];
        next.conditions = [...this.conditions];
        next.tests = [...this.tests];
        next.transforms = [...this.transforms];
        next.spec = clone(Object.assign({}, this.spec, spec));
        return next;
      }
      label(label) {
        let next = this.clone();
        next.spec.label = label;
        return next;
      }
      meta(...args) {
        if (args.length === 0) return this.spec.meta;
        let next = this.clone();
        next.spec.meta = Object.assign(next.spec.meta || {}, args[0]);
        return next;
      }
      withMutation(fn) {
        let before = this._mutate;
        this._mutate = true;
        let result = fn(this);
        this._mutate = before;
        return result;
      }
      concat(schema) {
        if (!schema || schema === this) return this;
        if (schema.type !== this.type && this.type !== 'mixed') throw new TypeError(`You cannot \`concat()\` schema's of different types: ${this.type} and ${schema.type}`);
        let base = this;
        let combined = schema.clone();
        const mergedSpec = Object.assign({}, base.spec, combined.spec);
        combined.spec = mergedSpec;
        combined.internalTests = Object.assign({}, base.internalTests, combined.internalTests);

        // manually merge the blacklist/whitelist (the other `schema` takes
        // precedence in case of conflicts)
        combined._whitelist = base._whitelist.merge(schema._whitelist, schema._blacklist);
        combined._blacklist = base._blacklist.merge(schema._blacklist, schema._whitelist);

        // start with the current tests
        combined.tests = base.tests;
        combined.exclusiveTests = base.exclusiveTests;

        // manually add the new tests to ensure
        // the deduping logic is consistent
        combined.withMutation(next => {
          schema.tests.forEach(fn => {
            next.test(fn.OPTIONS);
          });
        });
        combined.transforms = [...base.transforms, ...combined.transforms];
        return combined;
      }
      isType(v) {
        if (v == null) {
          if (this.spec.nullable && v === null) return true;
          if (this.spec.optional && v === undefined) return true;
          return false;
        }
        return this._typeCheck(v);
      }
      resolve(options) {
        let schema = this;
        if (schema.conditions.length) {
          let conditions = schema.conditions;
          schema = schema.clone();
          schema.conditions = [];
          schema = conditions.reduce((prevSchema, condition) => condition.resolve(prevSchema, options), schema);
          schema = schema.resolve(options);
        }
        return schema;
      }
      resolveOptions(options) {
        var _options$strict, _options$abortEarly, _options$recursive, _options$disableStack;
        return Object.assign({}, options, {
          from: options.from || [],
          strict: (_options$strict = options.strict) != null ? _options$strict : this.spec.strict,
          abortEarly: (_options$abortEarly = options.abortEarly) != null ? _options$abortEarly : this.spec.abortEarly,
          recursive: (_options$recursive = options.recursive) != null ? _options$recursive : this.spec.recursive,
          disableStackTrace: (_options$disableStack = options.disableStackTrace) != null ? _options$disableStack : this.spec.disableStackTrace
        });
      }

      /**
       * Run the configured transform pipeline over an input value.
       */

      cast(value, options = {}) {
        let resolvedSchema = this.resolve(Object.assign({
          value
        }, options));
        let allowOptionality = options.assert === 'ignore-optionality';
        let result = resolvedSchema._cast(value, options);
        if (options.assert !== false && !resolvedSchema.isType(result)) {
          if (allowOptionality && isAbsent(result)) {
            return result;
          }
          let formattedValue = printValue(value);
          let formattedResult = printValue(result);
          throw new TypeError(`The value of ${options.path || 'field'} could not be cast to a value ` + `that satisfies the schema type: "${resolvedSchema.type}". \n\n` + `attempted value: ${formattedValue} \n` + (formattedResult !== formattedValue ? `result of cast: ${formattedResult}` : ''));
        }
        return result;
      }
      _cast(rawValue, options) {
        let value = rawValue === undefined ? rawValue : this.transforms.reduce((prevValue, fn) => fn.call(this, prevValue, rawValue, this), rawValue);
        if (value === undefined) {
          value = this.getDefault(options);
        }
        return value;
      }
      _validate(_value, options = {}, panic, next) {
        let {
          path,
          originalValue = _value,
          strict = this.spec.strict
        } = options;
        let value = _value;
        if (!strict) {
          value = this._cast(value, Object.assign({
            assert: false
          }, options));
        }
        let initialTests = [];
        for (let test of Object.values(this.internalTests)) {
          if (test) initialTests.push(test);
        }
        this.runTests({
          path,
          value,
          originalValue,
          options,
          tests: initialTests
        }, panic, initialErrors => {
          // even if we aren't ending early we can't proceed further if the types aren't correct
          if (initialErrors.length) {
            return next(initialErrors, value);
          }
          this.runTests({
            path,
            value,
            originalValue,
            options,
            tests: this.tests
          }, panic, next);
        });
      }

      /**
       * Executes a set of validations, either schema, produced Tests or a nested
       * schema validate result.
       */
      runTests(runOptions, panic, next) {
        let fired = false;
        let {
          tests,
          value,
          originalValue,
          path,
          options
        } = runOptions;
        let panicOnce = arg => {
          if (fired) return;
          fired = true;
          panic(arg, value);
        };
        let nextOnce = arg => {
          if (fired) return;
          fired = true;
          next(arg, value);
        };
        let count = tests.length;
        let nestedErrors = [];
        if (!count) return nextOnce([]);
        let args = {
          value,
          originalValue,
          path,
          options,
          schema: this
        };
        for (let i = 0; i < tests.length; i++) {
          const test = tests[i];
          test(args, panicOnce, function finishTestRun(err) {
            if (err) {
              Array.isArray(err) ? nestedErrors.push(...err) : nestedErrors.push(err);
            }
            if (--count <= 0) {
              nextOnce(nestedErrors);
            }
          });
        }
      }
      asNestedTest({
        key,
        index,
        parent,
        parentPath,
        originalParent,
        options
      }) {
        const k = key != null ? key : index;
        if (k == null) {
          throw TypeError('Must include `key` or `index` for nested validations');
        }
        const isIndex = typeof k === 'number';
        let value = parent[k];
        const testOptions = Object.assign({}, options, {
          // Nested validations fields are always strict:
          //    1. parent isn't strict so the casting will also have cast inner values
          //    2. parent is strict in which case the nested values weren't cast either
          strict: true,
          parent,
          value,
          originalValue: originalParent[k],
          // FIXME: tests depend on `index` being passed around deeply,
          //   we should not let the options.key/index bleed through
          key: undefined,
          // index: undefined,
          [isIndex ? 'index' : 'key']: k,
          path: isIndex || k.includes('.') ? `${parentPath || ''}[${value ? k : `"${k}"`}]` : (parentPath ? `${parentPath}.` : '') + key
        });
        return (_, panic, next) => this.resolve(testOptions)._validate(value, testOptions, panic, next);
      }
      validate(value, options) {
        var _options$disableStack2;
        let schema = this.resolve(Object.assign({}, options, {
          value
        }));
        let disableStackTrace = (_options$disableStack2 = options == null ? void 0 : options.disableStackTrace) != null ? _options$disableStack2 : schema.spec.disableStackTrace;
        return new Promise((resolve, reject) => schema._validate(value, options, (error, parsed) => {
          if (ValidationError.isError(error)) error.value = parsed;
          reject(error);
        }, (errors, validated) => {
          if (errors.length) reject(new ValidationError(errors, validated, undefined, undefined, disableStackTrace));else resolve(validated);
        }));
      }
      validateSync(value, options) {
        var _options$disableStack3;
        let schema = this.resolve(Object.assign({}, options, {
          value
        }));
        let result;
        let disableStackTrace = (_options$disableStack3 = options == null ? void 0 : options.disableStackTrace) != null ? _options$disableStack3 : schema.spec.disableStackTrace;
        schema._validate(value, Object.assign({}, options, {
          sync: true
        }), (error, parsed) => {
          if (ValidationError.isError(error)) error.value = parsed;
          throw error;
        }, (errors, validated) => {
          if (errors.length) throw new ValidationError(errors, value, undefined, undefined, disableStackTrace);
          result = validated;
        });
        return result;
      }
      isValid(value, options) {
        return this.validate(value, options).then(() => true, err => {
          if (ValidationError.isError(err)) return false;
          throw err;
        });
      }
      isValidSync(value, options) {
        try {
          this.validateSync(value, options);
          return true;
        } catch (err) {
          if (ValidationError.isError(err)) return false;
          throw err;
        }
      }
      _getDefault(options) {
        let defaultValue = this.spec.default;
        if (defaultValue == null) {
          return defaultValue;
        }
        return typeof defaultValue === 'function' ? defaultValue.call(this, options) : clone(defaultValue);
      }
      getDefault(options
      // If schema is defaulted we know it's at least not undefined
      ) {
        let schema = this.resolve(options || {});
        return schema._getDefault(options);
      }
      default(def) {
        if (arguments.length === 0) {
          return this._getDefault();
        }
        let next = this.clone({
          default: def
        });
        return next;
      }
      strict(isStrict = true) {
        return this.clone({
          strict: isStrict
        });
      }
      nullability(nullable, message) {
        const next = this.clone({
          nullable
        });
        next.internalTests.nullable = createValidation({
          message,
          name: 'nullable',
          test(value) {
            return value === null ? this.schema.spec.nullable : true;
          }
        });
        return next;
      }
      optionality(optional, message) {
        const next = this.clone({
          optional
        });
        next.internalTests.optionality = createValidation({
          message,
          name: 'optionality',
          test(value) {
            return value === undefined ? this.schema.spec.optional : true;
          }
        });
        return next;
      }
      optional() {
        return this.optionality(true);
      }
      defined(message = mixed.defined) {
        return this.optionality(false, message);
      }
      nullable() {
        return this.nullability(true);
      }
      nonNullable(message = mixed.notNull) {
        return this.nullability(false, message);
      }
      required(message = mixed.required) {
        return this.clone().withMutation(next => next.nonNullable(message).defined(message));
      }
      notRequired() {
        return this.clone().withMutation(next => next.nullable().optional());
      }
      transform(fn) {
        let next = this.clone();
        next.transforms.push(fn);
        return next;
      }

      /**
       * Adds a test function to the schema's queue of tests.
       * tests can be exclusive or non-exclusive.
       *
       * - exclusive tests, will replace any existing tests of the same name.
       * - non-exclusive: can be stacked
       *
       * If a non-exclusive test is added to a schema with an exclusive test of the same name
       * the exclusive test is removed and further tests of the same name will be stacked.
       *
       * If an exclusive test is added to a schema with non-exclusive tests of the same name
       * the previous tests are removed and further tests of the same name will replace each other.
       */

      test(...args) {
        let opts;
        if (args.length === 1) {
          if (typeof args[0] === 'function') {
            opts = {
              test: args[0]
            };
          } else {
            opts = args[0];
          }
        } else if (args.length === 2) {
          opts = {
            name: args[0],
            test: args[1]
          };
        } else {
          opts = {
            name: args[0],
            message: args[1],
            test: args[2]
          };
        }
        if (opts.message === undefined) opts.message = mixed.default;
        if (typeof opts.test !== 'function') throw new TypeError('`test` is a required parameters');
        let next = this.clone();
        let validate = createValidation(opts);
        let isExclusive = opts.exclusive || opts.name && next.exclusiveTests[opts.name] === true;
        if (opts.exclusive) {
          if (!opts.name) throw new TypeError('Exclusive tests must provide a unique `name` identifying the test');
        }
        if (opts.name) next.exclusiveTests[opts.name] = !!opts.exclusive;
        next.tests = next.tests.filter(fn => {
          if (fn.OPTIONS.name === opts.name) {
            if (isExclusive) return false;
            if (fn.OPTIONS.test === validate.OPTIONS.test) return false;
          }
          return true;
        });
        next.tests.push(validate);
        return next;
      }
      when(keys, options) {
        if (!Array.isArray(keys) && typeof keys !== 'string') {
          options = keys;
          keys = '.';
        }
        let next = this.clone();
        let deps = toArray(keys).map(key => new Reference(key));
        deps.forEach(dep => {
          // @ts-ignore readonly array
          if (dep.isSibling) next.deps.push(dep.key);
        });
        next.conditions.push(typeof options === 'function' ? new Condition(deps, options) : Condition.fromOptions(deps, options));
        return next;
      }
      typeError(message) {
        let next = this.clone();
        next.internalTests.typeError = createValidation({
          message,
          name: 'typeError',
          skipAbsent: true,
          test(value) {
            if (!this.schema._typeCheck(value)) return this.createError({
              params: {
                type: this.schema.type
              }
            });
            return true;
          }
        });
        return next;
      }
      oneOf(enums, message = mixed.oneOf) {
        let next = this.clone();
        enums.forEach(val => {
          next._whitelist.add(val);
          next._blacklist.delete(val);
        });
        next.internalTests.whiteList = createValidation({
          message,
          name: 'oneOf',
          skipAbsent: true,
          test(value) {
            let valids = this.schema._whitelist;
            let resolved = valids.resolveAll(this.resolve);
            return resolved.includes(value) ? true : this.createError({
              params: {
                values: Array.from(valids).join(', '),
                resolved
              }
            });
          }
        });
        return next;
      }
      notOneOf(enums, message = mixed.notOneOf) {
        let next = this.clone();
        enums.forEach(val => {
          next._blacklist.add(val);
          next._whitelist.delete(val);
        });
        next.internalTests.blacklist = createValidation({
          message,
          name: 'notOneOf',
          test(value) {
            let invalids = this.schema._blacklist;
            let resolved = invalids.resolveAll(this.resolve);
            if (resolved.includes(value)) return this.createError({
              params: {
                values: Array.from(invalids).join(', '),
                resolved
              }
            });
            return true;
          }
        });
        return next;
      }
      strip(strip = true) {
        let next = this.clone();
        next.spec.strip = strip;
        return next;
      }

      /**
       * Return a serialized description of the schema including validations, flags, types etc.
       *
       * @param options Provide any needed context for resolving runtime schema alterations (lazy, when conditions, etc).
       */
      describe(options) {
        const next = (options ? this.resolve(options) : this).clone();
        const {
          label,
          meta,
          optional,
          nullable
        } = next.spec;
        const description = {
          meta,
          label,
          optional,
          nullable,
          default: next.getDefault(options),
          type: next.type,
          oneOf: next._whitelist.describe(),
          notOneOf: next._blacklist.describe(),
          tests: next.tests.map(fn => ({
            name: fn.OPTIONS.name,
            params: fn.OPTIONS.params
          })).filter((n, idx, list) => list.findIndex(c => c.name === n.name) === idx)
        };
        return description;
      }
    }
    // @ts-expect-error
    Schema.prototype.__isYupSchema__ = true;
    for (const method of ['validate', 'validateSync']) Schema.prototype[`${method}At`] = function (path, value, options = {}) {
      const {
        parent,
        parentPath,
        schema
      } = getIn(this, path, value, options.context);
      return schema[method](parent && parent[parentPath], Object.assign({}, options, {
        parent,
        path
      }));
    };
    for (const alias of ['equals', 'is']) Schema.prototype[alias] = Schema.prototype.oneOf;
    for (const alias of ['not', 'nope']) Schema.prototype[alias] = Schema.prototype.notOneOf;

    const returnsTrue = () => true;
    function create$8(spec) {
      return new MixedSchema(spec);
    }
    class MixedSchema extends Schema {
      constructor(spec) {
        super(typeof spec === 'function' ? {
          type: 'mixed',
          check: spec
        } : Object.assign({
          type: 'mixed',
          check: returnsTrue
        }, spec));
      }
    }
    create$8.prototype = MixedSchema.prototype;

    function create$7() {
      return new BooleanSchema();
    }
    class BooleanSchema extends Schema {
      constructor() {
        super({
          type: 'boolean',
          check(v) {
            if (v instanceof Boolean) v = v.valueOf();
            return typeof v === 'boolean';
          }
        });
        this.withMutation(() => {
          this.transform((value, _raw, ctx) => {
            if (ctx.spec.coerce && !ctx.isType(value)) {
              if (/^(true|1)$/i.test(String(value))) return true;
              if (/^(false|0)$/i.test(String(value))) return false;
            }
            return value;
          });
        });
      }
      isTrue(message = boolean.isValue) {
        return this.test({
          message,
          name: 'is-value',
          exclusive: true,
          params: {
            value: 'true'
          },
          test(value) {
            return isAbsent(value) || value === true;
          }
        });
      }
      isFalse(message = boolean.isValue) {
        return this.test({
          message,
          name: 'is-value',
          exclusive: true,
          params: {
            value: 'false'
          },
          test(value) {
            return isAbsent(value) || value === false;
          }
        });
      }
      default(def) {
        return super.default(def);
      }
      defined(msg) {
        return super.defined(msg);
      }
      optional() {
        return super.optional();
      }
      required(msg) {
        return super.required(msg);
      }
      notRequired() {
        return super.notRequired();
      }
      nullable() {
        return super.nullable();
      }
      nonNullable(msg) {
        return super.nonNullable(msg);
      }
      strip(v) {
        return super.strip(v);
      }
    }
    create$7.prototype = BooleanSchema.prototype;

    // Taken from HTML spec: https://html.spec.whatwg.org/multipage/input.html#valid-e-mail-address
    let rEmail =
    // eslint-disable-next-line
    /^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
    let rUrl =
    // eslint-disable-next-line
    /^((https?|ftp):)?\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i;

    // eslint-disable-next-line
    let rUUID = /^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;
    let isTrimmed = value => isAbsent(value) || value === value.trim();
    let objStringTag = {}.toString();
    function create$6() {
      return new StringSchema();
    }
    class StringSchema extends Schema {
      constructor() {
        super({
          type: 'string',
          check(value) {
            if (value instanceof String) value = value.valueOf();
            return typeof value === 'string';
          }
        });
        this.withMutation(() => {
          this.transform((value, _raw, ctx) => {
            if (!ctx.spec.coerce || ctx.isType(value)) return value;

            // don't ever convert arrays
            if (Array.isArray(value)) return value;
            const strValue = value != null && value.toString ? value.toString() : value;

            // no one wants plain objects converted to [Object object]
            if (strValue === objStringTag) return value;
            return strValue;
          });
        });
      }
      required(message) {
        return super.required(message).withMutation(schema => schema.test({
          message: message || mixed.required,
          name: 'required',
          skipAbsent: true,
          test: value => !!value.length
        }));
      }
      notRequired() {
        return super.notRequired().withMutation(schema => {
          schema.tests = schema.tests.filter(t => t.OPTIONS.name !== 'required');
          return schema;
        });
      }
      length(length, message = string.length) {
        return this.test({
          message,
          name: 'length',
          exclusive: true,
          params: {
            length
          },
          skipAbsent: true,
          test(value) {
            return value.length === this.resolve(length);
          }
        });
      }
      min(min, message = string.min) {
        return this.test({
          message,
          name: 'min',
          exclusive: true,
          params: {
            min
          },
          skipAbsent: true,
          test(value) {
            return value.length >= this.resolve(min);
          }
        });
      }
      max(max, message = string.max) {
        return this.test({
          name: 'max',
          exclusive: true,
          message,
          params: {
            max
          },
          skipAbsent: true,
          test(value) {
            return value.length <= this.resolve(max);
          }
        });
      }
      matches(regex, options) {
        let excludeEmptyString = false;
        let message;
        let name;
        if (options) {
          if (typeof options === 'object') {
            ({
              excludeEmptyString = false,
              message,
              name
            } = options);
          } else {
            message = options;
          }
        }
        return this.test({
          name: name || 'matches',
          message: message || string.matches,
          params: {
            regex
          },
          skipAbsent: true,
          test: value => value === '' && excludeEmptyString || value.search(regex) !== -1
        });
      }
      email(message = string.email) {
        return this.matches(rEmail, {
          name: 'email',
          message,
          excludeEmptyString: true
        });
      }
      url(message = string.url) {
        return this.matches(rUrl, {
          name: 'url',
          message,
          excludeEmptyString: true
        });
      }
      uuid(message = string.uuid) {
        return this.matches(rUUID, {
          name: 'uuid',
          message,
          excludeEmptyString: false
        });
      }

      //-- transforms --
      ensure() {
        return this.default('').transform(val => val === null ? '' : val);
      }
      trim(message = string.trim) {
        return this.transform(val => val != null ? val.trim() : val).test({
          message,
          name: 'trim',
          test: isTrimmed
        });
      }
      lowercase(message = string.lowercase) {
        return this.transform(value => !isAbsent(value) ? value.toLowerCase() : value).test({
          message,
          name: 'string_case',
          exclusive: true,
          skipAbsent: true,
          test: value => isAbsent(value) || value === value.toLowerCase()
        });
      }
      uppercase(message = string.uppercase) {
        return this.transform(value => !isAbsent(value) ? value.toUpperCase() : value).test({
          message,
          name: 'string_case',
          exclusive: true,
          skipAbsent: true,
          test: value => isAbsent(value) || value === value.toUpperCase()
        });
      }
    }
    create$6.prototype = StringSchema.prototype;

    //
    // String Interfaces
    //

    let isNaN$1 = value => value != +value;
    function create$5() {
      return new NumberSchema();
    }
    class NumberSchema extends Schema {
      constructor() {
        super({
          type: 'number',
          check(value) {
            if (value instanceof Number) value = value.valueOf();
            return typeof value === 'number' && !isNaN$1(value);
          }
        });
        this.withMutation(() => {
          this.transform((value, _raw, ctx) => {
            if (!ctx.spec.coerce) return value;
            let parsed = value;
            if (typeof parsed === 'string') {
              parsed = parsed.replace(/\s/g, '');
              if (parsed === '') return NaN;
              // don't use parseFloat to avoid positives on alpha-numeric strings
              parsed = +parsed;
            }

            // null -> NaN isn't useful; treat all nulls as null and let it fail on
            // nullability check vs TypeErrors
            if (ctx.isType(parsed) || parsed === null) return parsed;
            return parseFloat(parsed);
          });
        });
      }
      min(min, message = number.min) {
        return this.test({
          message,
          name: 'min',
          exclusive: true,
          params: {
            min
          },
          skipAbsent: true,
          test(value) {
            return value >= this.resolve(min);
          }
        });
      }
      max(max, message = number.max) {
        return this.test({
          message,
          name: 'max',
          exclusive: true,
          params: {
            max
          },
          skipAbsent: true,
          test(value) {
            return value <= this.resolve(max);
          }
        });
      }
      lessThan(less, message = number.lessThan) {
        return this.test({
          message,
          name: 'max',
          exclusive: true,
          params: {
            less
          },
          skipAbsent: true,
          test(value) {
            return value < this.resolve(less);
          }
        });
      }
      moreThan(more, message = number.moreThan) {
        return this.test({
          message,
          name: 'min',
          exclusive: true,
          params: {
            more
          },
          skipAbsent: true,
          test(value) {
            return value > this.resolve(more);
          }
        });
      }
      positive(msg = number.positive) {
        return this.moreThan(0, msg);
      }
      negative(msg = number.negative) {
        return this.lessThan(0, msg);
      }
      integer(message = number.integer) {
        return this.test({
          name: 'integer',
          message,
          skipAbsent: true,
          test: val => Number.isInteger(val)
        });
      }
      truncate() {
        return this.transform(value => !isAbsent(value) ? value | 0 : value);
      }
      round(method) {
        var _method;
        let avail = ['ceil', 'floor', 'round', 'trunc'];
        method = ((_method = method) == null ? void 0 : _method.toLowerCase()) || 'round';

        // this exists for symemtry with the new Math.trunc
        if (method === 'trunc') return this.truncate();
        if (avail.indexOf(method.toLowerCase()) === -1) throw new TypeError('Only valid options for round() are: ' + avail.join(', '));
        return this.transform(value => !isAbsent(value) ? Math[method](value) : value);
      }
    }
    create$5.prototype = NumberSchema.prototype;

    // @ts-expect-error
    function sortFields(fields, excludedEdges = []) {
      let edges = [];
      let nodes = new Set();
      let excludes = new Set(excludedEdges.map(([a, b]) => `${a}-${b}`));
      function addNode(depPath, key) {
        let node = propertyExpr.split(depPath)[0];
        nodes.add(node);
        if (!excludes.has(`${key}-${node}`)) edges.push([key, node]);
      }
      for (const key of Object.keys(fields)) {
        let value = fields[key];
        nodes.add(key);
        if (Reference.isRef(value) && value.isSibling) addNode(value.path, key);else if (isSchema(value) && 'deps' in value) value.deps.forEach(path => addNode(path, key));
      }
      return toposort_1.array(Array.from(nodes), edges).reverse();
    }

    function findIndex(arr, err) {
      let idx = Infinity;
      arr.some((key, ii) => {
        var _err$path;
        if ((_err$path = err.path) != null && _err$path.includes(key)) {
          idx = ii;
          return true;
        }
      });
      return idx;
    }
    function sortByKeyOrder(keys) {
      return (a, b) => {
        return findIndex(keys, a) - findIndex(keys, b);
      };
    }

    const parseJson = (value, _, ctx) => {
      if (typeof value !== 'string') {
        return value;
      }
      let parsed = value;
      try {
        parsed = JSON.parse(value);
      } catch (err) {
        /* */
      }
      return ctx.isType(parsed) ? parsed : value;
    };

    // @ts-ignore
    function deepPartial(schema) {
      if ('fields' in schema) {
        const partial = {};
        for (const [key, fieldSchema] of Object.entries(schema.fields)) {
          partial[key] = deepPartial(fieldSchema);
        }
        return schema.setFields(partial);
      }
      if (schema.type === 'array') {
        const nextArray = schema.optional();
        if (nextArray.innerType) nextArray.innerType = deepPartial(nextArray.innerType);
        return nextArray;
      }
      if (schema.type === 'tuple') {
        return schema.optional().clone({
          types: schema.spec.types.map(deepPartial)
        });
      }
      if ('optional' in schema) {
        return schema.optional();
      }
      return schema;
    }
    const deepHas = (obj, p) => {
      const path = [...propertyExpr.normalizePath(p)];
      if (path.length === 1) return path[0] in obj;
      let last = path.pop();
      let parent = propertyExpr.getter(propertyExpr.join(path), true)(obj);
      return !!(parent && last in parent);
    };
    let isObject = obj => Object.prototype.toString.call(obj) === '[object Object]';
    function unknown(ctx, value) {
      let known = Object.keys(ctx.fields);
      return Object.keys(value).filter(key => known.indexOf(key) === -1);
    }
    const defaultSort = sortByKeyOrder([]);
    function create$3(spec) {
      return new ObjectSchema(spec);
    }
    class ObjectSchema extends Schema {
      constructor(spec) {
        super({
          type: 'object',
          check(value) {
            return isObject(value) || typeof value === 'function';
          }
        });
        this.fields = Object.create(null);
        this._sortErrors = defaultSort;
        this._nodes = [];
        this._excludedEdges = [];
        this.withMutation(() => {
          if (spec) {
            this.shape(spec);
          }
        });
      }
      _cast(_value, options = {}) {
        var _options$stripUnknown;
        let value = super._cast(_value, options);

        //should ignore nulls here
        if (value === undefined) return this.getDefault(options);
        if (!this._typeCheck(value)) return value;
        let fields = this.fields;
        let strip = (_options$stripUnknown = options.stripUnknown) != null ? _options$stripUnknown : this.spec.noUnknown;
        let props = [].concat(this._nodes, Object.keys(value).filter(v => !this._nodes.includes(v)));
        let intermediateValue = {}; // is filled during the transform below
        let innerOptions = Object.assign({}, options, {
          parent: intermediateValue,
          __validating: options.__validating || false
        });
        let isChanged = false;
        for (const prop of props) {
          let field = fields[prop];
          let exists = (prop in value);
          if (field) {
            let fieldValue;
            let inputValue = value[prop];

            // safe to mutate since this is fired in sequence
            innerOptions.path = (options.path ? `${options.path}.` : '') + prop;
            field = field.resolve({
              value: inputValue,
              context: options.context,
              parent: intermediateValue
            });
            let fieldSpec = field instanceof Schema ? field.spec : undefined;
            let strict = fieldSpec == null ? void 0 : fieldSpec.strict;
            if (fieldSpec != null && fieldSpec.strip) {
              isChanged = isChanged || prop in value;
              continue;
            }
            fieldValue = !options.__validating || !strict ?
            // TODO: use _cast, this is double resolving
            field.cast(value[prop], innerOptions) : value[prop];
            if (fieldValue !== undefined) {
              intermediateValue[prop] = fieldValue;
            }
          } else if (exists && !strip) {
            intermediateValue[prop] = value[prop];
          }
          if (exists !== prop in intermediateValue || intermediateValue[prop] !== value[prop]) {
            isChanged = true;
          }
        }
        return isChanged ? intermediateValue : value;
      }
      _validate(_value, options = {}, panic, next) {
        let {
          from = [],
          originalValue = _value,
          recursive = this.spec.recursive
        } = options;
        options.from = [{
          schema: this,
          value: originalValue
        }, ...from];
        // this flag is needed for handling `strict` correctly in the context of
        // validation vs just casting. e.g strict() on a field is only used when validating
        options.__validating = true;
        options.originalValue = originalValue;
        super._validate(_value, options, panic, (objectErrors, value) => {
          if (!recursive || !isObject(value)) {
            next(objectErrors, value);
            return;
          }
          originalValue = originalValue || value;
          let tests = [];
          for (let key of this._nodes) {
            let field = this.fields[key];
            if (!field || Reference.isRef(field)) {
              continue;
            }
            tests.push(field.asNestedTest({
              options,
              key,
              parent: value,
              parentPath: options.path,
              originalParent: originalValue
            }));
          }
          this.runTests({
            tests,
            value,
            originalValue,
            options
          }, panic, fieldErrors => {
            next(fieldErrors.sort(this._sortErrors).concat(objectErrors), value);
          });
        });
      }
      clone(spec) {
        const next = super.clone(spec);
        next.fields = Object.assign({}, this.fields);
        next._nodes = this._nodes;
        next._excludedEdges = this._excludedEdges;
        next._sortErrors = this._sortErrors;
        return next;
      }
      concat(schema) {
        let next = super.concat(schema);
        let nextFields = next.fields;
        for (let [field, schemaOrRef] of Object.entries(this.fields)) {
          const target = nextFields[field];
          nextFields[field] = target === undefined ? schemaOrRef : target;
        }
        return next.withMutation(s =>
        // XXX: excludes here is wrong
        s.setFields(nextFields, [...this._excludedEdges, ...schema._excludedEdges]));
      }
      _getDefault(options) {
        if ('default' in this.spec) {
          return super._getDefault(options);
        }

        // if there is no default set invent one
        if (!this._nodes.length) {
          return undefined;
        }
        let dft = {};
        this._nodes.forEach(key => {
          var _innerOptions;
          const field = this.fields[key];
          let innerOptions = options;
          if ((_innerOptions = innerOptions) != null && _innerOptions.value) {
            innerOptions = Object.assign({}, innerOptions, {
              parent: innerOptions.value,
              value: innerOptions.value[key]
            });
          }
          dft[key] = field && 'getDefault' in field ? field.getDefault(innerOptions) : undefined;
        });
        return dft;
      }
      setFields(shape, excludedEdges) {
        let next = this.clone();
        next.fields = shape;
        next._nodes = sortFields(shape, excludedEdges);
        next._sortErrors = sortByKeyOrder(Object.keys(shape));
        // XXX: this carries over edges which may not be what you want
        if (excludedEdges) next._excludedEdges = excludedEdges;
        return next;
      }
      shape(additions, excludes = []) {
        return this.clone().withMutation(next => {
          let edges = next._excludedEdges;
          if (excludes.length) {
            if (!Array.isArray(excludes[0])) excludes = [excludes];
            edges = [...next._excludedEdges, ...excludes];
          }

          // XXX: excludes here is wrong
          return next.setFields(Object.assign(next.fields, additions), edges);
        });
      }
      partial() {
        const partial = {};
        for (const [key, schema] of Object.entries(this.fields)) {
          partial[key] = 'optional' in schema && schema.optional instanceof Function ? schema.optional() : schema;
        }
        return this.setFields(partial);
      }
      deepPartial() {
        const next = deepPartial(this);
        return next;
      }
      pick(keys) {
        const picked = {};
        for (const key of keys) {
          if (this.fields[key]) picked[key] = this.fields[key];
        }
        return this.setFields(picked, this._excludedEdges.filter(([a, b]) => keys.includes(a) && keys.includes(b)));
      }
      omit(keys) {
        const remaining = [];
        for (const key of Object.keys(this.fields)) {
          if (keys.includes(key)) continue;
          remaining.push(key);
        }
        return this.pick(remaining);
      }
      from(from, to, alias) {
        let fromGetter = propertyExpr.getter(from, true);
        return this.transform(obj => {
          if (!obj) return obj;
          let newObj = obj;
          if (deepHas(obj, from)) {
            newObj = Object.assign({}, obj);
            if (!alias) delete newObj[from];
            newObj[to] = fromGetter(obj);
          }
          return newObj;
        });
      }

      /** Parse an input JSON string to an object */
      json() {
        return this.transform(parseJson);
      }
      noUnknown(noAllow = true, message = object.noUnknown) {
        if (typeof noAllow !== 'boolean') {
          message = noAllow;
          noAllow = true;
        }
        let next = this.test({
          name: 'noUnknown',
          exclusive: true,
          message: message,
          test(value) {
            if (value == null) return true;
            const unknownKeys = unknown(this.schema, value);
            return !noAllow || unknownKeys.length === 0 || this.createError({
              params: {
                unknown: unknownKeys.join(', ')
              }
            });
          }
        });
        next.spec.noUnknown = noAllow;
        return next;
      }
      unknown(allow = true, message = object.noUnknown) {
        return this.noUnknown(!allow, message);
      }
      transformKeys(fn) {
        return this.transform(obj => {
          if (!obj) return obj;
          const result = {};
          for (const key of Object.keys(obj)) result[fn(key)] = obj[key];
          return result;
        });
      }
      camelCase() {
        return this.transformKeys(tinyCase.camelCase);
      }
      snakeCase() {
        return this.transformKeys(tinyCase.snakeCase);
      }
      constantCase() {
        return this.transformKeys(key => tinyCase.snakeCase(key).toUpperCase());
      }
      describe(options) {
        const next = (options ? this.resolve(options) : this).clone();
        const base = super.describe(options);
        base.fields = {};
        for (const [key, value] of Object.entries(next.fields)) {
          var _innerOptions2;
          let innerOptions = options;
          if ((_innerOptions2 = innerOptions) != null && _innerOptions2.value) {
            innerOptions = Object.assign({}, innerOptions, {
              parent: innerOptions.value,
              value: innerOptions.value[key]
            });
          }
          base.fields[key] = value.describe(innerOptions);
        }
        return base;
      }
    }
    create$3.prototype = ObjectSchema.prototype;

    function create$2(type) {
      return new ArraySchema(type);
    }
    class ArraySchema extends Schema {
      constructor(type) {
        super({
          type: 'array',
          spec: {
            types: type
          },
          check(v) {
            return Array.isArray(v);
          }
        });

        // `undefined` specifically means uninitialized, as opposed to "no subtype"
        this.innerType = void 0;
        this.innerType = type;
      }
      _cast(_value, _opts) {
        const value = super._cast(_value, _opts);

        // should ignore nulls here
        if (!this._typeCheck(value) || !this.innerType) {
          return value;
        }
        let isChanged = false;
        const castArray = value.map((v, idx) => {
          const castElement = this.innerType.cast(v, Object.assign({}, _opts, {
            path: `${_opts.path || ''}[${idx}]`
          }));
          if (castElement !== v) {
            isChanged = true;
          }
          return castElement;
        });
        return isChanged ? castArray : value;
      }
      _validate(_value, options = {}, panic, next) {
        var _options$recursive;
        // let sync = options.sync;
        // let path = options.path;
        let innerType = this.innerType;
        // let endEarly = options.abortEarly ?? this.spec.abortEarly;
        let recursive = (_options$recursive = options.recursive) != null ? _options$recursive : this.spec.recursive;
        options.originalValue != null ? options.originalValue : _value;
        super._validate(_value, options, panic, (arrayErrors, value) => {
          var _options$originalValu2;
          if (!recursive || !innerType || !this._typeCheck(value)) {
            next(arrayErrors, value);
            return;
          }

          // #950 Ensure that sparse array empty slots are validated
          let tests = new Array(value.length);
          for (let index = 0; index < value.length; index++) {
            var _options$originalValu;
            tests[index] = innerType.asNestedTest({
              options,
              index,
              parent: value,
              parentPath: options.path,
              originalParent: (_options$originalValu = options.originalValue) != null ? _options$originalValu : _value
            });
          }
          this.runTests({
            value,
            tests,
            originalValue: (_options$originalValu2 = options.originalValue) != null ? _options$originalValu2 : _value,
            options
          }, panic, innerTypeErrors => next(innerTypeErrors.concat(arrayErrors), value));
        });
      }
      clone(spec) {
        const next = super.clone(spec);
        // @ts-expect-error readonly
        next.innerType = this.innerType;
        return next;
      }

      /** Parse an input JSON string to an object */
      json() {
        return this.transform(parseJson);
      }
      concat(schema) {
        let next = super.concat(schema);

        // @ts-expect-error readonly
        next.innerType = this.innerType;
        if (schema.innerType)
          // @ts-expect-error readonly
          next.innerType = next.innerType ?
          // @ts-expect-error Lazy doesn't have concat and will break
          next.innerType.concat(schema.innerType) : schema.innerType;
        return next;
      }
      of(schema) {
        // FIXME: this should return a new instance of array without the default to be
        let next = this.clone();
        if (!isSchema(schema)) throw new TypeError('`array.of()` sub-schema must be a valid yup schema not: ' + printValue(schema));

        // @ts-expect-error readonly
        next.innerType = schema;
        next.spec = Object.assign({}, next.spec, {
          types: schema
        });
        return next;
      }
      length(length, message = array.length) {
        return this.test({
          message,
          name: 'length',
          exclusive: true,
          params: {
            length
          },
          skipAbsent: true,
          test(value) {
            return value.length === this.resolve(length);
          }
        });
      }
      min(min, message) {
        message = message || array.min;
        return this.test({
          message,
          name: 'min',
          exclusive: true,
          params: {
            min
          },
          skipAbsent: true,
          // FIXME(ts): Array<typeof T>
          test(value) {
            return value.length >= this.resolve(min);
          }
        });
      }
      max(max, message) {
        message = message || array.max;
        return this.test({
          message,
          name: 'max',
          exclusive: true,
          params: {
            max
          },
          skipAbsent: true,
          test(value) {
            return value.length <= this.resolve(max);
          }
        });
      }
      ensure() {
        return this.default(() => []).transform((val, original) => {
          // We don't want to return `null` for nullable schema
          if (this._typeCheck(val)) return val;
          return original == null ? [] : [].concat(original);
        });
      }
      compact(rejector) {
        let reject = !rejector ? v => !!v : (v, i, a) => !rejector(v, i, a);
        return this.transform(values => values != null ? values.filter(reject) : values);
      }
      describe(options) {
        const next = (options ? this.resolve(options) : this).clone();
        const base = super.describe(options);
        if (next.innerType) {
          var _innerOptions;
          let innerOptions = options;
          if ((_innerOptions = innerOptions) != null && _innerOptions.value) {
            innerOptions = Object.assign({}, innerOptions, {
              parent: innerOptions.value,
              value: innerOptions.value[0]
            });
          }
          base.innerType = next.innerType.describe(innerOptions);
        }
        return base;
      }
    }
    create$2.prototype = ArraySchema.prototype;

    var currencyType = function () { return create$5().min(-1); };
    var numberType = function () { return create$5(); };
    var cartProductSchema = create$3({
        product_id: create$6().required(),
        sku: create$6().required(),
        quantity: numberType().required(),
        price: currencyType().required(),
        // optional properties
        name: create$6().optional(),
        price_from: currencyType().optional(),
        category: create$6().optional(),
        brand: create$6().optional(),
        url: create$6().optional(),
        image_url: create$6().optional(),
        properties: create$3().optional(),
        recovery_properties: create$3().optional(),
    });
    var addressSchema = create$3({
        postal_code: create$6().optional(),
        address_line1: create$6().optional(),
        address_number: create$6().optional(),
        address_line2: create$6().optional(),
        city: create$6().optional(),
        state: create$6().optional(),
        country: create$6().optional(),
        neighborhood: create$6().optional(),
    }).default(undefined);
    var cartAddSchema = create$3({
        products: create$2().of(cartProductSchema).required(),
    }).test('products', 'products must have at least one item', function (p) { var _a; return ((_a = p === null || p === void 0 ? void 0 : p.products) === null || _a === void 0 ? void 0 : _a.length) > 0; });
    var cartItemUpdateSchema = create$3({
        cart_id: create$6().required(),
        product_id: create$6().required(),
        sku: create$6().required(),
        quantity: numberType().required(),
    });
    var cartSetCouponSchema = create$3({
        cart_id: create$6().required(),
        coupon: create$6().defined(),
    });
    var cartSetPostalCodeSchema = create$3({
        cart_id: create$6().required(),
        postal_code: create$6().defined(),
    });
    var cartSyncSchema = create$3({
        cart: create$3({
            cart_id: create$6().required(),
            subtotal: currencyType().required(),
            total: currencyType().required(),
            freight: currencyType().required(),
            tax: currencyType().required(),
            discounts: currencyType().required(),
            // optional properties
            currency: create$6().optional(),
            items: create$2().of(cartProductSchema).optional(),
            delivery_address: addressSchema.optional(),
            coupons: create$6().optional(),
        }).required(),
    });
    var checkoutStepSchema = create$3({
        checkout: create$3({
            cart_id: create$6().required(),
            step: create$5().min(1).required(),
            total_steps: create$5().min(1).required(),
            step_name: create$6().required(),
        }).required(),
    });
    var optionMethodSchema = create$3({
        type: create$6().required(),
        amount: currencyType().required(),
    });
    var orderSchema = create$3({
        cart_id: create$6().required(),
        subtotal: currencyType().required(),
        total: currencyType().required(),
        freight: currencyType().required(),
        tax: currencyType().required(),
        discounts: currencyType().required(),
        // optional properties
        currency: create$6().optional(),
        order_id: create$6().optional(),
        coupons: create$6().optional(),
        delivery_address: addressSchema.optional(),
        items: create$2().of(cartProductSchema).optional(),
        payment_methods: create$2().of(optionMethodSchema).optional(),
        delivery_methods: create$2().of(optionMethodSchema).optional(),
    });
    var orderCompleteSchema = create$3({
        order: orderSchema.required(),
    });
    var orderCancelSchema = create$3({
        order_id: create$6().optional(),
        cart_id: create$6().optional(),
    }).test('order_id or cart_id', 'order_id or cart_id is required', function (o) { return !!((o === null || o === void 0 ? void 0 : o.order_id) || (o === null || o === void 0 ? void 0 : o.cart_id)); });
    var productVariantSchema = create$3({
        sku: create$6().required(),
        price: currencyType().required(),
        // optional properties
        name: create$6().optional(),
        url: create$6().optional(),
        image_url: create$6().optional(),
        price_from: currencyType().optional(),
        stock: numberType().optional(),
        available: create$7().optional(),
        properties: create$3().optional(),
        recovery_properties: create$3().optional(),
    });
    var productSchema = create$3({
        product_id: create$6().required(),
        variants: create$2().of(productVariantSchema).required(),
        // optional properties
        url: create$6().optional(),
        category: create$6().optional(),
        brand: create$6().optional(),
    }).test('variants', 'variants must have at least one item', function (p) { var _a; return ((_a = p === null || p === void 0 ? void 0 : p.variants) === null || _a === void 0 ? void 0 : _a.length) > 0; });
    var productViewSchema = create$3({
        product: productSchema.required(),
    });
    var userSchema = create$3({
        user_id: create$6().lowercase(),
        email: create$6().email().lowercase(),
        // optional properties
        phone: create$6().optional(),
        name: create$6().optional(),
        plan: create$6().optional(),
        created_at: create$6().optional(),
    }).test('user_id or email', 'user_id or email is required', function (u) { return !!((u === null || u === void 0 ? void 0 : u.user_id) || (u === null || u === void 0 ? void 0 : u.email)); });
    var accountSyncSchema = create$3({
        user: userSchema.required(),
    });
    var accountLoginSchema = accountSyncSchema.clone();
    var noSchema = create$8();

    var _a;
    var $d;
    var core = {};
    var localState;
    // Record is a compiled record of gathered data that might become unavailable
    var recordManager;
    var eventToSchemaMap = (_a = {},
        _a[Events.pageView] = noSchema,
        _a[Events.accountLogin] = accountLoginSchema,
        _a[Events.accountSync] = accountSyncSchema,
        _a[Events.productView] = productViewSchema,
        _a[Events.orderComplete] = orderCompleteSchema,
        _a[Events.orderCancel] = orderCancelSchema,
        _a[Events.checkoutStep] = checkoutStepSchema,
        _a[Events.cartSync] = cartSyncSchema,
        _a[Events.addToCart] = cartAddSchema,
        _a[Events.cartItemUpdate] = cartItemUpdateSchema,
        _a[Events.cartSetPostalCode] = cartSetPostalCodeSchema,
        _a[Events.cartSetCoupon] = cartSetCouponSchema,
        _a);
    var validateEventOrLogError = function (eventName, eventData) { return __awaiter(void 0, void 0, void 0, function () {
        var validatedEvent, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, eventToSchemaMap[eventName].validate(eventData)];
                case 1:
                    validatedEvent = _a.sent();
                    return [2 /*return*/, validatedEvent];
                case 2:
                    e_1 = _a.sent();
                    LOG.error(e_1);
                    return [2 /*return*/, null];
                case 3: return [2 /*return*/];
            }
        });
    }); };
    var setUserIdOnApi = function (e) {
        var _a, _b;
        (_a = core.api) === null || _a === void 0 ? void 0 : _a.setUserId((_b = e.user.user_id) !== null && _b !== void 0 ? _b : '', e.user.email);
    };
    var universalTrackerShim = function (eventName, eventData) { return __awaiter(void 0, void 0, void 0, function () {
        var validatedEvent, enrichedEvent, supportsEnrichment;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, validateEventOrLogError(eventName, eventData)];
                case 1:
                    validatedEvent = _b.sent();
                    if (!validatedEvent) {
                        return [2 /*return*/];
                    }
                    enrichedEvent = validatedEvent;
                    supportsEnrichment = Object.keys(SupportedEventsForRecordingEnum).includes(eventName);
                    if (supportsEnrichment) {
                        enrichedEvent = recordManager.enrichEvent(eventName, validatedEvent);
                    }
                    //
                    // Send event
                    //
                    // @ts-ignore
                    (_a = core.tracker) === null || _a === void 0 ? void 0 : _a[eventName](enrichedEvent);
                    //
                    // AccountSync and AccountLogin specifics
                    //
                    if ([Events.accountSync, Events.accountLogin].includes(eventName)) {
                        setUserIdOnApi(enrichedEvent);
                    }
                    return [2 /*return*/];
            }
        });
    }); };
    //#region bootstrap
    function safeInitCoreMbTrack() {
        var _a, _b;
        // Create the mbtrack function
        window.mbtrack =
            (_a = window.mbtrack) !== null && _a !== void 0 ? _a : function () {
                var _a;
                (window.mbtrack.q = (_a = window.mbtrack.q) !== null && _a !== void 0 ? _a : []).push(arguments);
            };
        // Initialize the asynchronous queue
        window.mbtrack.q = (_b = window.mbtrack.q) !== null && _b !== void 0 ? _b : [];
    }
    function bootstrapUniversalTracker() {
        var coreMbTrack = window.mbtrack;
        window.mb_track = function (eventName, eventData) {
            var _a;
            LOG.debug('Universal: track event', arguments);
            var isEvent = isFunction((_a = core === null || core === void 0 ? void 0 : core.tracker) === null || _a === void 0 ? void 0 : _a[eventName]);
            if (isEvent) {
                universalTrackerShim(eventName, eventData);
            }
            else {
                coreMbTrack === null || coreMbTrack === void 0 ? void 0 : coreMbTrack.apply(this, arguments);
            }
        };
    }
    function processInitialEventsQueue(queue) {
        queue === null || queue === void 0 ? void 0 : queue.forEach(function (_a) {
            var eventName = _a[0], eventData = _a[1];
            if (typeof eventName === 'string') {
                window === null || window === void 0 ? void 0 : window.mb_track(eventName, eventData);
            }
        });
    }
    function bootstrap() {
        var _a;
        // Safe define mbtrack and its queue
        // This will allow queue to be transferred to the tracker, it is expecting it
        safeInitCoreMbTrack();
        // Consolidate initial event queue
        var eventsQueue = ((_a = window === null || window === void 0 ? void 0 : window.mb_track) === null || _a === void 0 ? void 0 : _a.q) || [];
        LOG.debug('Universal: Event queue', eventsQueue);
        // Apply shim to mb_track method
        bootstrapUniversalTracker();
        // Then, run initial event queue
        setTimeout(function () { return processInitialEventsQueue(eventsQueue); }, 10);
    }
    function validateBootstrap() {
        var warn;
        var error;
        if (!$d) {
            warn = 'Universal: DomHelper not found';
        }
        if (!core || typeof core !== 'object') {
            error = 'Universal: vendorInstance.core is null or is not an object.';
        }
        warn && LOG.warn(warn);
        error && LOG.error(error);
        return !warn && !error;
    }
    function init(vendorInstance) {
        var _a;
        // Basics
        $d = (_a = window === null || window === void 0 ? void 0 : window._mbz_) === null || _a === void 0 ? void 0 : _a.$;
        core = vendorInstance.core;
        recordManager = new RecordManager(vendorInstance.onsiteSettings.app_id);
        localState = {
            init: false,
        };
    }
    function bootstrapVendorTracker(vendorInstance) {
        init(vendorInstance);
        if (localState.init || !validateBootstrap()) {
            return;
        }
        bootstrap();
        localState.init = true;
    }
    //#endregion

    var version = "0.3.0";

    var UniversalVendor = /** @class */ (function (_super) {
        __extends(UniversalVendor, _super);
        function UniversalVendor() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.runtimeSettings = {
                version: version,
            };
            _this.shouldBootstrapVendor = function () {
                if (isWindowIframe()) {
                    LOG.debug('Stopping vendor bootstrap: iframe detected');
                    return false;
                }
                return true;
            };
            _this.shouldTrackPageView = function () { return true; };
            _this.bootstrapVendorTracker = bootstrapVendorTracker;
            _this.bootstrapVendorCartRecovery = bootstrapVendorCartRecovery;
            return _this;
        }
        UniversalVendor.prototype.destroy = function () { };
        return UniversalVendor;
    }(VendorBase));

    var vendor = new UniversalVendor();
    vendor.bootstrap(onsiteCore);

}());
